define(['dart_sdk', 'test/test__shared_2', 'packages/test/lib__test', 'packages/w_transport/lib__w_transport', 'packages/matcher/lib__shared_0'], function(dart_sdk, test__shared_2, lib__test, lib__w_transport, lib__shared_0) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const test = lib__test.test;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const src__frontend__throws_matchers = lib__test.src__frontend__throws_matchers;
  const src__frontend__throws_matcher = lib__test.src__frontend__throws_matcher;
  const src__global_transport_platform = lib__w_transport.src__global_transport_platform;
  const src__http__requests = lib__w_transport.src__http__requests;
  const src__transport_platform = lib__w_transport.src__transport_platform;
  const src__http__http_client = lib__w_transport.src__http__http_client;
  const src__web_socket__web_socket = lib__w_transport.src__web_socket__web_socket;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const integration__platforms__transport_platform_test = Object.create(null);
  let isInstanceOfOfTransportPlatformMissing = () => (isInstanceOfOfTransportPlatformMissing = dart.constFn(src__core_matchers.isInstanceOf$(src__transport_platform.TransportPlatformMissing)))();
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let MapOfString$dynamic = () => (MapOfString$dynamic = dart.constFn(core.Map$(core.String, dart.dynamic)))();
  let IterableOfString = () => (IterableOfString = dart.constFn(core.Iterable$(core.String)))();
  let ListOfString = () => (ListOfString = dart.constFn(core.List$(core.String)))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let dynamicTobool = () => (dynamicTobool = dart.constFn(dart.fnType(core.bool, [dart.dynamic])))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let VoidTovoid = () => (VoidTovoid = dart.constFn(dart.fnType(dart.void, [])))();
  integration__platforms__transport_platform_test.main = function() {
    let naming = new naming$.Naming();
    naming.testType = naming$.testTypeIntegration;
    naming.topic = naming$.topicTransportPlatform;
    test.group(naming.toString(), dart.fn(() => {
      test.tearDown(dart.fn(() => {
        src__global_transport_platform.resetGlobalTransportPlatform();
      }, VoidToNull()));
      test.test('no global TP by default', dart.fn(() => {
        src__frontend__expect.expect(src__global_transport_platform.globalTransportPlatform, src__core_matchers.isNull);
      }, VoidToNull()));
      test.test('global TP can be set', dart.fn(() => {
        src__global_transport_platform.globalTransportPlatform = integration__platforms__transport_platform_test.stubTransportPlatform;
        src__frontend__expect.expect(src__global_transport_platform.globalTransportPlatform, src__core_matchers.equals(integration__platforms__transport_platform_test.stubTransportPlatform));
      }, VoidToNull()));
      test.test('global TP cannot be set to null', dart.fn(() => {
        src__frontend__expect.expect(dart.fn(() => {
          src__global_transport_platform.globalTransportPlatform = null;
        }, VoidToNull()), src__frontend__throws_matchers.throwsArgumentError);
      }, VoidToNull()));
      test.test('constructing any HTTP class without a TP throws a TransportPlatformMissing', dart.fn(() => {
        src__frontend__expect.expect(dart.fn(() => {
          src__http__requests.FormRequest.new();
        }, VoidToNull()), src__frontend__throws_matcher.throwsA(src__core_matchers.predicate(dart.dynamic)(dart.fn(exception => src__transport_platform.TransportPlatformMissing.is(exception) && dart.test(dart.toString(exception)[dartx.contains]('Cannot send FormRequest - Missing Transport Platform')), dynamicTobool()))));
        src__frontend__expect.expect(dart.fn(() => {
          src__http__http_client.HttpClient.new();
        }, VoidToNull()), src__frontend__throws_matcher.throwsA(src__core_matchers.predicate(dart.dynamic)(dart.fn(exception => src__transport_platform.TransportPlatformMissing.is(exception) && dart.test(dart.toString(exception)[dartx.contains]('Cannot construct an HTTP Client - Missing Transport Platform')), dynamicTobool()))));
        src__frontend__expect.expect(dart.fn(() => {
          src__http__requests.JsonRequest.new();
        }, VoidToNull()), src__frontend__throws_matcher.throwsA(src__core_matchers.predicate(dart.dynamic)(dart.fn(exception => src__transport_platform.TransportPlatformMissing.is(exception) && dart.test(dart.toString(exception)[dartx.contains]('Cannot send JsonRequest - Missing Transport Platform')), dynamicTobool()))));
        src__frontend__expect.expect(dart.fn(() => {
          src__http__requests.MultipartRequest.new();
        }, VoidToNull()), src__frontend__throws_matcher.throwsA(src__core_matchers.predicate(dart.dynamic)(dart.fn(exception => src__transport_platform.TransportPlatformMissing.is(exception) && dart.test(dart.toString(exception)[dartx.contains]('Cannot send MultipartRequest - Missing Transport Platform')), dynamicTobool()))));
        src__frontend__expect.expect(dart.fn(() => {
          src__http__requests.Request.new();
        }, VoidToNull()), src__frontend__throws_matcher.throwsA(src__core_matchers.predicate(dart.dynamic)(dart.fn(exception => src__transport_platform.TransportPlatformMissing.is(exception) && dart.test(dart.toString(exception)[dartx.contains]('Cannot send Request - Missing Transport Platform')), dynamicTobool()))));
        src__frontend__expect.expect(dart.fn(() => {
          src__http__requests.StreamedRequest.new();
        }, VoidToNull()), src__frontend__throws_matcher.throwsA(src__core_matchers.predicate(dart.dynamic)(dart.fn(exception => src__transport_platform.TransportPlatformMissing.is(exception) && dart.test(dart.toString(exception)[dartx.contains]('Cannot send StreamedRequest - Missing Transport Platform')), dynamicTobool()))));
      }, VoidToNull()));
      test.test('establishing a WS connection without a TP throws a TransportPlatformMissing', dart.fn(() => {
        src__frontend__expect.expect(src__web_socket__web_socket.WebSocket.connect(core.Uri.parse('/')), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfTransportPlatformMissing())()));
      }, VoidToNull()));
      test.test('constructing any HTTP class without a TP will inherit the global', dart.fn(() => {
        src__global_transport_platform.globalTransportPlatform = integration__platforms__transport_platform_test.stubTransportPlatform;
        src__frontend__expect.expect(src__http__requests.FormRequest.new(), src__core_matchers.isNull);
        src__frontend__expect.expect(src__http__http_client.HttpClient.new(), src__core_matchers.isNull);
        src__frontend__expect.expect(src__http__requests.JsonRequest.new(), src__core_matchers.isNull);
        src__frontend__expect.expect(src__http__requests.MultipartRequest.new(), src__core_matchers.isNull);
        src__frontend__expect.expect(src__http__requests.Request.new(), src__core_matchers.isNull);
        src__frontend__expect.expect(src__http__requests.StreamedRequest.new(), src__core_matchers.isNull);
      }, VoidToNull()));
      test.test('establishing a WS connection without a TP will inherit the global', dart.fn(() => dart.async(function*() {
        src__global_transport_platform.globalTransportPlatform = integration__platforms__transport_platform_test.stubTransportPlatform;
        src__frontend__expect.expect(yield src__web_socket__web_socket.WebSocket.connect(core.Uri.parse('/')), src__core_matchers.isNull);
      }, core.Null), VoidToFutureOfNull()));
      test.test('constructing any HTTP class with a TP does not throw', dart.fn(() => {
        src__frontend__expect.expect(src__http__requests.FormRequest.new({transportPlatform: integration__platforms__transport_platform_test.stubTransportPlatform}), src__core_matchers.isNull);
        src__frontend__expect.expect(src__http__http_client.HttpClient.new({transportPlatform: integration__platforms__transport_platform_test.stubTransportPlatform}), src__core_matchers.isNull);
        src__frontend__expect.expect(src__http__requests.JsonRequest.new({transportPlatform: integration__platforms__transport_platform_test.stubTransportPlatform}), src__core_matchers.isNull);
        src__frontend__expect.expect(src__http__requests.MultipartRequest.new({transportPlatform: integration__platforms__transport_platform_test.stubTransportPlatform}), src__core_matchers.isNull);
        src__frontend__expect.expect(src__http__requests.Request.new({transportPlatform: integration__platforms__transport_platform_test.stubTransportPlatform}), src__core_matchers.isNull);
        src__frontend__expect.expect(src__http__requests.StreamedRequest.new({transportPlatform: integration__platforms__transport_platform_test.stubTransportPlatform}), src__core_matchers.isNull);
      }, VoidToNull()));
      test.test('establishing a WS connection with a TP does not throw', dart.fn(() => dart.async(function*() {
        src__frontend__expect.expect(yield src__web_socket__web_socket.WebSocket.connect(core.Uri.parse('/'), {transportPlatform: integration__platforms__transport_platform_test.stubTransportPlatform}), src__core_matchers.isNull);
      }, core.Null), VoidToFutureOfNull()));
    }, VoidToNull()));
  };
  dart.fn(integration__platforms__transport_platform_test.main, VoidTovoid());
  dart.defineLazy(integration__platforms__transport_platform_test, {
    get stubTransportPlatform() {
      return dart.const(new integration__platforms__transport_platform_test.StubTransportPlatform());
    }
  });
  integration__platforms__transport_platform_test.StubTransportPlatform = class StubTransportPlatform extends core.Object {
    new() {
    }
    newHttpClient() {
      return null;
    }
    newWebSocket(uri, opts) {
      return dart.async(function*(uri, opts) {
        let headers = opts && 'headers' in opts ? opts.headers : null;
        let protocols = opts && 'protocols' in opts ? opts.protocols : null;
        let sockJSDebug = opts && 'sockJSDebug' in opts ? opts.sockJSDebug : null;
        let sockJSNoCredentials = opts && 'sockJSNoCredentials' in opts ? opts.sockJSNoCredentials : null;
        let sockJSProtocolsWhitelist = opts && 'sockJSProtocolsWhitelist' in opts ? opts.sockJSProtocolsWhitelist : null;
        let sockJSTimeout = opts && 'sockJSTimeout' in opts ? opts.sockJSTimeout : null;
        let useSockJS = opts && 'useSockJS' in opts ? opts.useSockJS : null;
        return null;
      }, src__web_socket__web_socket.WebSocket, uri, opts);
    }
    newStreamedRequest() {
      return null;
    }
    newRequest() {
      return null;
    }
    newMultipartRequest() {
      return null;
    }
    newJsonRequest() {
      return null;
    }
    newFormRequest() {
      return null;
    }
  };
  integration__platforms__transport_platform_test.StubTransportPlatform[dart.implements] = () => [src__transport_platform.TransportPlatform];
  dart.setSignature(integration__platforms__transport_platform_test.StubTransportPlatform, {
    methods: () => ({
      newHttpClient: dart.fnType(src__http__http_client.HttpClient, []),
      newWebSocket: dart.fnType(async.Future$(src__web_socket__web_socket.WebSocket), [core.Uri], {headers: MapOfString$dynamic(), protocols: IterableOfString(), sockJSDebug: core.bool, sockJSNoCredentials: core.bool, sockJSProtocolsWhitelist: ListOfString(), sockJSTimeout: core.Duration, useSockJS: core.bool}),
      newStreamedRequest: dart.fnType(src__http__requests.StreamedRequest, []),
      newRequest: dart.fnType(src__http__requests.Request, []),
      newMultipartRequest: dart.fnType(src__http__requests.MultipartRequest, []),
      newJsonRequest: dart.fnType(src__http__requests.JsonRequest, []),
      newFormRequest: dart.fnType(src__http__requests.FormRequest, [])
    })
  });
  dart.trackLibraries("test/test__integration__platforms__transport_platform_test", {
    "integration/platforms/transport_platform_test.dart": integration__platforms__transport_platform_test
  }, null);
  // Exports:
  return {
    integration__platforms__transport_platform_test: integration__platforms__transport_platform_test
  };
});
