define(['dart_sdk'], function(dart_sdk) {
  'use strict';
  const core = dart_sdk.core;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const integration__integration_paths = Object.create(null);
  integration__integration_paths.IntegrationPaths = class IntegrationPaths extends core.Object {};
  dart.defineLazy(integration__integration_paths.IntegrationPaths, {
    get hostUri() {
      return core.Uri.parse('http://localhost:8024');
    },
    get wsHostUri() {
      return integration__integration_paths.IntegrationPaths.hostUri.replace({scheme: 'ws'});
    },
    get customEndpointUri() {
      return integration__integration_paths.IntegrationPaths.hostUri.replace({path: '/test/http/custom'});
    },
    get customEndpointUriPattern() {
      return core.RegExp.new(dart.notNull(dart.toString(integration__integration_paths.IntegrationPaths.customEndpointUri)[dartx.replaceAll]('/', '/')) + '(\\?.*)');
    },
    get downloadEndpointUri() {
      return integration__integration_paths.IntegrationPaths.hostUri.replace({path: '/test/http/download'});
    },
    get echoEndpointUri() {
      return integration__integration_paths.IntegrationPaths.hostUri.replace({path: '/test/http/echo'});
    },
    get errorEndpointUri() {
      return integration__integration_paths.IntegrationPaths.hostUri.replace({path: '/test/http/error'});
    },
    get fourOhFourEndpointUri() {
      return integration__integration_paths.IntegrationPaths.hostUri.replace({path: '/test/http/404'});
    },
    get pingEndpointUri() {
      return integration__integration_paths.IntegrationPaths.hostUri.replace({path: '/test/http/ping'});
    },
    get reflectEndpointUri() {
      return integration__integration_paths.IntegrationPaths.hostUri.replace({path: '/test/http/reflect'});
    },
    get timeoutEndpointUri() {
      return integration__integration_paths.IntegrationPaths.hostUri.replace({path: '/test/http/timeout'});
    },
    get uploadEndpointUri() {
      return integration__integration_paths.IntegrationPaths.hostUri.replace({path: '/test/http/upload'});
    },
    get closeUri() {
      return integration__integration_paths.IntegrationPaths.wsHostUri.replace({path: '/test/ws/close'});
    },
    get echoUri() {
      return integration__integration_paths.IntegrationPaths.wsHostUri.replace({path: '/test/ws/echo'});
    },
    get fourOhFourUri() {
      return core.Uri.parse('ws://localhost:9999');
    },
    get pingUri() {
      return integration__integration_paths.IntegrationPaths.wsHostUri.replace({path: '/test/ws/ping'});
    }
  });
  dart.trackLibraries("test/test__shared_0", {
    "integration/integration_paths.dart": integration__integration_paths
  }, null);
  // Exports:
  return {
    integration__integration_paths: integration__integration_paths
  };
});
