define(['dart_sdk', 'packages/test/lib__test', 'packages/w_transport/lib__w_transport', 'test/test__shared_0', 'packages/matcher/lib__shared_0'], function(dart_sdk, lib__test, lib__w_transport, test__shared_0, lib__shared_0) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const _interceptors = dart_sdk._interceptors;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const test = lib__test.test;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const src__frontend__throws_matchers = lib__test.src__frontend__throws_matchers;
  const src__frontend__throws_matcher = lib__test.src__frontend__throws_matcher;
  const src__http__client = lib__w_transport.src__http__client;
  const src__http__http_client = lib__w_transport.src__http__http_client;
  const src__transport_platform = lib__w_transport.src__transport_platform;
  const src__http__request_exception = lib__w_transport.src__http__request_exception;
  const src__http__base_request = lib__w_transport.src__http__base_request;
  const integration__integration_paths = test__shared_0.integration__integration_paths;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const src__map_matchers = lib__shared_0.src__map_matchers;
  const integration__http__client__suite = Object.create(null);
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let JSArrayOfFuture = () => (JSArrayOfFuture = dart.constFn(_interceptors.JSArray$(async.Future)))();
  let isInstanceOfOfRequestException = () => (isInstanceOfOfRequestException = dart.constFn(src__core_matchers.isInstanceOf$(src__http__request_exception.RequestException)))();
  let VoidToClient = () => (VoidToClient = dart.constFn(dart.fnTypeFuzzy(src__http__client.Client, [])))();
  let VoidToClient$ = () => (VoidToClient$ = dart.constFn(dart.fnType(src__http__client.Client, [])))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let VoidToHttpClient = () => (VoidToHttpClient = dart.constFn(dart.fnType(src__http__http_client.HttpClient, [])))();
  let __Tovoid = () => (__Tovoid = dart.constFn(dart.fnType(dart.void, [], [src__transport_platform.TransportPlatform])))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let FnTovoid = () => (FnTovoid = dart.constFn(dart.fnType(dart.void, [VoidToClient()])))();
  let BaseRequestToFutureOfNull = () => (BaseRequestToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [src__http__base_request.BaseRequest])))();
  integration__http__client__suite.runHttpTransportClientSuite = function(transportPlatform) {
    if (transportPlatform === void 0) transportPlatform = null;
    test.group('Client', dart.fn(() => {
      integration__http__client__suite._runHttpClientSuite(dart.fn(() => src__http__client.Client.new({transportPlatform: transportPlatform}), VoidToClient$()));
    }, VoidToNull()));
    test.group('HttpClient', dart.fn(() => {
      integration__http__client__suite._runHttpClientSuite(dart.fn(() => src__http__http_client.HttpClient.new({transportPlatform: transportPlatform}), VoidToHttpClient()));
    }, VoidToNull()));
  };
  dart.fn(integration__http__client__suite.runHttpTransportClientSuite, __Tovoid());
  integration__http__client__suite._runHttpClientSuite = function(getClient) {
    let client = null;
    test.setUp(dart.fn(() => {
      client = getClient();
    }, VoidToNull()));
    test.test('newFormRequest()', dart.fn(() => dart.async(function*() {
      let request = client.newFormRequest();
      yield integration__http__client__suite._testRequest(request);
      client.close();
    }, core.Null), VoidToFutureOfNull()));
    test.test('newJsonRequest()', dart.fn(() => dart.async(function*() {
      let request = client.newJsonRequest();
      yield integration__http__client__suite._testRequest(request);
      client.close();
    }, core.Null), VoidToFutureOfNull()));
    test.test('newMultipartRequest()', dart.fn(() => dart.async(function*() {
      let request = client.newMultipartRequest();
      request.fields[dartx._set]('key', 'value');
      yield integration__http__client__suite._testRequest(request);
      client.close();
    }, core.Null), VoidToFutureOfNull()));
    test.test('newRequest()', dart.fn(() => dart.async(function*() {
      let request = client.newRequest();
      yield integration__http__client__suite._testRequest(request);
      client.close();
    }, core.Null), VoidToFutureOfNull()));
    test.test('newStreamedRequest()', dart.fn(() => dart.async(function*() {
      let request = client.newStreamedRequest();
      yield integration__http__client__suite._testRequest(request);
      client.close();
    }, core.Null), VoidToFutureOfNull()));
    test.test('should support multiple concurrent requests', dart.fn(() => dart.async(function*() {
      let requests = JSArrayOfFuture().of([client.newFormRequest().post({uri: integration__integration_paths.IntegrationPaths.reflectEndpointUri}), client.newJsonRequest().put({uri: integration__integration_paths.IntegrationPaths.reflectEndpointUri}), (() => {
          let _ = client.newMultipartRequest();
          _.fields[dartx._set]('f', 'v');
          return _;
        })().patch({uri: integration__integration_paths.IntegrationPaths.reflectEndpointUri}), client.newRequest().get({uri: integration__integration_paths.IntegrationPaths.reflectEndpointUri}), client.newStreamedRequest().delete({uri: integration__integration_paths.IntegrationPaths.reflectEndpointUri}), client.newRequest().send('OPTIONS', {uri: integration__integration_paths.IntegrationPaths.reflectEndpointUri})]);
      yield async.Future.wait(dart.dynamic)(requests);
    }, core.Null), VoidToFutureOfNull()));
    test.test('close() should prevent new requests from being created', dart.fn(() => dart.async(function*() {
      client.close();
      src__frontend__expect.expect(dart.fn(() => {
        client.newRequest();
      }, VoidToNull()), src__frontend__throws_matchers.throwsStateError);
    }, core.Null), VoidToFutureOfNull()));
    test.test('close() should abort all in-flight requests', dart.fn(() => dart.async(function*() {
      let willComplete = client.newRequest();
      yield willComplete.get({uri: integration__integration_paths.IntegrationPaths.pingEndpointUri});
      let willNotComplete = client.newRequest();
      let willThrow = willNotComplete.get({uri: integration__integration_paths.IntegrationPaths.timeoutEndpointUri});
      client.close();
      src__frontend__expect.expect(willThrow, src__frontend__throws_matcher.throwsA(new (isInstanceOfOfRequestException())()));
    }, core.Null), VoidToFutureOfNull()));
  };
  dart.fn(integration__http__client__suite._runHttpClientSuite, FnTovoid());
  integration__http__client__suite._testRequest = function(request) {
    return dart.async(function*(request) {
      request.uri = integration__integration_paths.IntegrationPaths.reflectEndpointUri;
      request.headers = dart.map({'x-custom': 'value', 'x-tokens': 'token1, token2'}, core.String, core.String);
      let response = (yield request.get());
      src__frontend__expect.expect(dart.dindex(response.body.asJson(), 'method'), src__core_matchers.equals('GET'));
      src__frontend__expect.expect(dart.dindex(response.body.asJson(), 'headers'), src__map_matchers.containsPair('x-custom', 'value'));
      src__frontend__expect.expect(dart.dindex(response.body.asJson(), 'headers'), src__map_matchers.containsPair('x-tokens', 'token1, token2'));
    }, core.Null, request);
  };
  dart.fn(integration__http__client__suite._testRequest, BaseRequestToFutureOfNull());
  dart.trackLibraries("test/test__shared_4", {
    "integration/http/client/suite.dart": integration__http__client__suite
  }, null);
  // Exports:
  return {
    integration__http__client__suite: integration__http__client__suite
  };
});
