define(['dart_sdk', 'packages/test/lib__test', 'test/test__shared_0', 'packages/w_transport/lib__w_transport', 'packages/matcher/lib__shared_0', 'packages/dart2_constant/lib__convert'], function(dart_sdk, lib__test, test__shared_0, lib__w_transport, lib__shared_0, lib__convert) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const test = lib__test.test;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const integration__integration_paths = test__shared_0.integration__integration_paths;
  const src__http__http = lib__w_transport.src__http__http;
  const src__http__response = lib__w_transport.src__http__response;
  const src__transport_platform = lib__w_transport.src__transport_platform;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const src__map_matchers = lib__shared_0.src__map_matchers;
  const convert = lib__convert.convert;
  const integration__http__http_static__suite = Object.create(null);
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let MapOfString$String = () => (MapOfString$String = dart.constFn(core.Map$(core.String, core.String)))();
  let FutureOfString = () => (FutureOfString = dart.constFn(async.Future$(core.String)))();
  let FutureOrOfMap = () => (FutureOrOfMap = dart.constFn(async.FutureOr$(core.Map)))();
  let FutureOfMap = () => (FutureOfMap = dart.constFn(async.Future$(core.Map)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let StreamedResponseToFutureOfString = () => (StreamedResponseToFutureOfString = dart.constFn(dart.fnType(FutureOfString(), [src__http__response.StreamedResponse])))();
  let StreamedResponseToFutureOfMap = () => (StreamedResponseToFutureOfMap = dart.constFn(dart.fnType(FutureOfMap(), [src__http__response.StreamedResponse])))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let __Tovoid = () => (__Tovoid = dart.constFn(dart.fnType(dart.void, [], [src__transport_platform.TransportPlatform])))();
  integration__http__http_static__suite.runHttpStaticSuite = function(transportPlatform) {
    if (transportPlatform === void 0) transportPlatform = null;
    test.group('Http static methods', dart.fn(() => {
      let headers = dart.map({authorization: 'test', 'x-custom': 'value', 'x-tokens': 'token1, token2'}, core.String, core.String);
      test.test('DELETE request', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.delete(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        src__frontend__expect.expect(dart.dindex(response.body.asJson(), 'method'), src__core_matchers.equals('DELETE'));
      }, core.Null), VoidToFutureOfNull()));
      test.test('DELETE request with headers', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.delete(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {headers: MapOfString$String().from(headers), transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = response.body.asJson();
        src__frontend__expect.expect(dart.dindex(json, 'method'), src__core_matchers.equals('DELETE'));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('authorization', headers[dartx._get]('authorization')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-custom', headers[dartx._get]('x-custom')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-tokens', headers[dartx._get]('x-tokens')));
      }, core.Null), VoidToFutureOfNull()));
      test.test('GET request', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.get(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        src__frontend__expect.expect(dart.dindex(response.body.asJson(), 'method'), src__core_matchers.equals('GET'));
      }, core.Null), VoidToFutureOfNull()));
      test.test('GET request with headers', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.get(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {headers: MapOfString$String().from(headers), transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = response.body.asJson();
        src__frontend__expect.expect(dart.dindex(json, 'method'), src__core_matchers.equals('GET'));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('authorization', headers[dartx._get]('authorization')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-custom', headers[dartx._get]('x-custom')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-tokens', headers[dartx._get]('x-tokens')));
      }, core.Null), VoidToFutureOfNull()));
      test.test('HEAD request', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.head(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
      }, core.Null), VoidToFutureOfNull()));
      test.test('HEAD request with headers', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.head(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {headers: MapOfString$String().from(headers), transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
      }, core.Null), VoidToFutureOfNull()));
      test.test('OPTIONS request', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.options(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        src__frontend__expect.expect(dart.dindex(response.body.asJson(), 'method'), src__core_matchers.equals('OPTIONS'));
      }, core.Null), VoidToFutureOfNull()));
      test.test('OPTIONS request with headers', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.options(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {headers: MapOfString$String().from(headers), transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = response.body.asJson();
        src__frontend__expect.expect(dart.dindex(json, 'method'), src__core_matchers.equals('OPTIONS'));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('authorization', headers[dartx._get]('authorization')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-custom', headers[dartx._get]('x-custom')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-tokens', headers[dartx._get]('x-tokens')));
      }, core.Null), VoidToFutureOfNull()));
      test.test('PATCH request', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.patch(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        src__frontend__expect.expect(dart.dindex(response.body.asJson(), 'method'), src__core_matchers.equals('PATCH'));
      }, core.Null), VoidToFutureOfNull()));
      test.test('PATCH request with headers', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.patch(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {headers: MapOfString$String().from(headers), transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = response.body.asJson();
        src__frontend__expect.expect(dart.dindex(json, 'method'), src__core_matchers.equals('PATCH'));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('authorization', headers[dartx._get]('authorization')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-custom', headers[dartx._get]('x-custom')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-tokens', headers[dartx._get]('x-tokens')));
      }, core.Null), VoidToFutureOfNull()));
      test.test('PATCH request with body', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.patch(integration__integration_paths.IntegrationPaths.echoEndpointUri, {body: 'body', transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.body.asString(), src__core_matchers.equals('body'));
      }, core.Null), VoidToFutureOfNull()));
      test.test('POST request', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.post(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        src__frontend__expect.expect(dart.dindex(response.body.asJson(), 'method'), src__core_matchers.equals('POST'));
      }, core.Null), VoidToFutureOfNull()));
      test.test('POST request with headers', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.post(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {headers: MapOfString$String().from(headers), transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = response.body.asJson();
        src__frontend__expect.expect(dart.dindex(json, 'method'), src__core_matchers.equals('POST'));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('authorization', headers[dartx._get]('authorization')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-custom', headers[dartx._get]('x-custom')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-tokens', headers[dartx._get]('x-tokens')));
      }, core.Null), VoidToFutureOfNull()));
      test.test('POST request with body', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.post(integration__integration_paths.IntegrationPaths.echoEndpointUri, {body: 'body', transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.body.asString(), src__core_matchers.equals('body'));
      }, core.Null), VoidToFutureOfNull()));
      test.test('PUT request', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.put(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        src__frontend__expect.expect(dart.dindex(response.body.asJson(), 'method'), src__core_matchers.equals('PUT'));
      }, core.Null), VoidToFutureOfNull()));
      test.test('PUT request with headers', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.put(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {headers: MapOfString$String().from(headers), transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = response.body.asJson();
        src__frontend__expect.expect(dart.dindex(json, 'method'), src__core_matchers.equals('PUT'));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('authorization', headers[dartx._get]('authorization')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-custom', headers[dartx._get]('x-custom')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-tokens', headers[dartx._get]('x-tokens')));
      }, core.Null), VoidToFutureOfNull()));
      test.test('PUT request with body', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.put(integration__integration_paths.IntegrationPaths.echoEndpointUri, {body: 'body', transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.body.asString(), src__core_matchers.equals('body'));
      }, core.Null), VoidToFutureOfNull()));
      test.test('custom HTTP method request', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.send('COPY', integration__integration_paths.IntegrationPaths.reflectEndpointUri, {transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        src__frontend__expect.expect(dart.dindex(response.body.asJson(), 'method'), src__core_matchers.equals('COPY'));
      }, core.Null), VoidToFutureOfNull()));
      test.test('custom HTTP method request with headers', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.send('COPY', integration__integration_paths.IntegrationPaths.reflectEndpointUri, {headers: MapOfString$String().from(headers), transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = response.body.asJson();
        src__frontend__expect.expect(dart.dindex(json, 'method'), src__core_matchers.equals('COPY'));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('authorization', headers[dartx._get]('authorization')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-custom', headers[dartx._get]('x-custom')));
        src__frontend__expect.expect(dart.dindex(json, 'headers'), src__map_matchers.containsPair('x-tokens', headers[dartx._get]('x-tokens')));
      }, core.Null), VoidToFutureOfNull()));
      test.test('custom HTTP method request with body', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.send('COPY', integration__integration_paths.IntegrationPaths.echoEndpointUri, {body: 'body', transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.body.asString(), src__core_matchers.equals('body'));
      }, core.Null), VoidToFutureOfNull()));
      function _decodeStreamedResponseToString(response) {
        return dart.async(function*(response) {
          let bytes = (yield response.body.toBytes());
          return response.encoding.decode(bytes[dartx.toList]());
        }, core.String, response);
      }
      dart.fn(_decodeStreamedResponseToString, StreamedResponseToFutureOfString());
      function _decodeStreamedResponseToJson(response) {
        return dart.async(function*(response) {
          return FutureOrOfMap()._check(convert.json.decode(yield _decodeStreamedResponseToString(response)));
        }, core.Map, response);
      }
      dart.fn(_decodeStreamedResponseToJson, StreamedResponseToFutureOfMap());
      test.test('streamed DELETE request', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.streamDelete(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = (yield _decodeStreamedResponseToJson(response));
        src__frontend__expect.expect(json[dartx._get]('method'), src__core_matchers.equals('DELETE'));
      }, core.Null), VoidToFutureOfNull()));
      test.test('streamed DELETE request with headers', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.streamDelete(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {headers: MapOfString$String().from(headers), transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = (yield _decodeStreamedResponseToJson(response));
        src__frontend__expect.expect(json[dartx._get]('method'), src__core_matchers.equals('DELETE'));
        src__frontend__expect.expect(json[dartx._get]('headers'), src__map_matchers.containsPair('authorization', headers[dartx._get]('authorization')));
        src__frontend__expect.expect(json[dartx._get]('headers'), src__map_matchers.containsPair('x-custom', headers[dartx._get]('x-custom')));
        src__frontend__expect.expect(json[dartx._get]('headers'), src__map_matchers.containsPair('x-tokens', headers[dartx._get]('x-tokens')));
      }, core.Null), VoidToFutureOfNull()));
      test.test('streamed GET request', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.streamGet(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = (yield _decodeStreamedResponseToJson(response));
        src__frontend__expect.expect(json[dartx._get]('method'), src__core_matchers.equals('GET'));
      }, core.Null), VoidToFutureOfNull()));
      test.test('streamed GET request with headers', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.streamGet(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {headers: MapOfString$String().from(headers), transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = (yield _decodeStreamedResponseToJson(response));
        src__frontend__expect.expect(json[dartx._get]('method'), src__core_matchers.equals('GET'));
        src__frontend__expect.expect(json[dartx._get]('headers'), src__map_matchers.containsPair('authorization', headers[dartx._get]('authorization')));
        src__frontend__expect.expect(json[dartx._get]('headers'), src__map_matchers.containsPair('x-custom', headers[dartx._get]('x-custom')));
        src__frontend__expect.expect(json[dartx._get]('headers'), src__map_matchers.containsPair('x-tokens', headers[dartx._get]('x-tokens')));
      }, core.Null), VoidToFutureOfNull()));
      test.test('streamed HEAD request', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.streamHead(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
      }, core.Null), VoidToFutureOfNull()));
      test.test('streamed HEAD request with headers', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.streamHead(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {headers: MapOfString$String().from(headers), transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
      }, core.Null), VoidToFutureOfNull()));
      test.test('streamed OPTIONS request', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.streamOptions(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = (yield _decodeStreamedResponseToJson(response));
        src__frontend__expect.expect(json[dartx._get]('method'), src__core_matchers.equals('OPTIONS'));
      }, core.Null), VoidToFutureOfNull()));
      test.test('streamed OPTIONS request with headers', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.streamOptions(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {headers: MapOfString$String().from(headers), transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = (yield _decodeStreamedResponseToJson(response));
        src__frontend__expect.expect(json[dartx._get]('method'), src__core_matchers.equals('OPTIONS'));
        src__frontend__expect.expect(json[dartx._get]('headers'), src__map_matchers.containsPair('authorization', headers[dartx._get]('authorization')));
        src__frontend__expect.expect(json[dartx._get]('headers'), src__map_matchers.containsPair('x-custom', headers[dartx._get]('x-custom')));
        src__frontend__expect.expect(json[dartx._get]('headers'), src__map_matchers.containsPair('x-tokens', headers[dartx._get]('x-tokens')));
      }, core.Null), VoidToFutureOfNull()));
      test.test('streamed PATCH request', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.streamPatch(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = (yield _decodeStreamedResponseToJson(response));
        src__frontend__expect.expect(json[dartx._get]('method'), src__core_matchers.equals('PATCH'));
      }, core.Null), VoidToFutureOfNull()));
      test.test('streamed PATCH request with headers', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.streamPatch(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {headers: MapOfString$String().from(headers), transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = (yield _decodeStreamedResponseToJson(response));
        src__frontend__expect.expect(json[dartx._get]('method'), src__core_matchers.equals('PATCH'));
        src__frontend__expect.expect(json[dartx._get]('headers'), src__map_matchers.containsPair('authorization', headers[dartx._get]('authorization')));
        src__frontend__expect.expect(json[dartx._get]('headers'), src__map_matchers.containsPair('x-custom', headers[dartx._get]('x-custom')));
        src__frontend__expect.expect(json[dartx._get]('headers'), src__map_matchers.containsPair('x-tokens', headers[dartx._get]('x-tokens')));
      }, core.Null), VoidToFutureOfNull()));
      test.test('streamed PATCH request with body', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.streamPatch(integration__integration_paths.IntegrationPaths.echoEndpointUri, {body: 'body', transportPlatform: transportPlatform}));
        let body = (yield _decodeStreamedResponseToString(response));
        src__frontend__expect.expect(body, src__core_matchers.equals('body'));
      }, core.Null), VoidToFutureOfNull()));
      test.test('streamed POST request', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.streamPost(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = (yield _decodeStreamedResponseToJson(response));
        src__frontend__expect.expect(json[dartx._get]('method'), src__core_matchers.equals('POST'));
      }, core.Null), VoidToFutureOfNull()));
      test.test('streamed POST request with headers', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.streamPost(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {headers: MapOfString$String().from(headers), transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = (yield _decodeStreamedResponseToJson(response));
        src__frontend__expect.expect(json[dartx._get]('method'), src__core_matchers.equals('POST'));
        src__frontend__expect.expect(json[dartx._get]('headers'), src__map_matchers.containsPair('authorization', headers[dartx._get]('authorization')));
        src__frontend__expect.expect(json[dartx._get]('headers'), src__map_matchers.containsPair('x-custom', headers[dartx._get]('x-custom')));
        src__frontend__expect.expect(json[dartx._get]('headers'), src__map_matchers.containsPair('x-tokens', headers[dartx._get]('x-tokens')));
      }, core.Null), VoidToFutureOfNull()));
      test.test('streamed POST request with body', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.streamPost(integration__integration_paths.IntegrationPaths.echoEndpointUri, {body: 'body', transportPlatform: transportPlatform}));
        let body = (yield _decodeStreamedResponseToString(response));
        src__frontend__expect.expect(body, src__core_matchers.equals('body'));
      }, core.Null), VoidToFutureOfNull()));
      test.test('streamed PUT request', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.streamPut(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = (yield _decodeStreamedResponseToJson(response));
        src__frontend__expect.expect(json[dartx._get]('method'), src__core_matchers.equals('PUT'));
      }, core.Null), VoidToFutureOfNull()));
      test.test('streamed PUT request with headers', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.streamPut(integration__integration_paths.IntegrationPaths.reflectEndpointUri, {headers: MapOfString$String().from(headers), transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = (yield _decodeStreamedResponseToJson(response));
        src__frontend__expect.expect(json[dartx._get]('method'), src__core_matchers.equals('PUT'));
        src__frontend__expect.expect(json[dartx._get]('headers'), src__map_matchers.containsPair('authorization', headers[dartx._get]('authorization')));
        src__frontend__expect.expect(json[dartx._get]('headers'), src__map_matchers.containsPair('x-custom', headers[dartx._get]('x-custom')));
        src__frontend__expect.expect(json[dartx._get]('headers'), src__map_matchers.containsPair('x-tokens', headers[dartx._get]('x-tokens')));
      }, core.Null), VoidToFutureOfNull()));
      test.test('streamed PUT request with body', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.streamPut(integration__integration_paths.IntegrationPaths.echoEndpointUri, {body: 'body', transportPlatform: transportPlatform}));
        let body = (yield _decodeStreamedResponseToString(response));
        src__frontend__expect.expect(body, src__core_matchers.equals('body'));
      }, core.Null), VoidToFutureOfNull()));
      test.test('streamed custom HTTP method request', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.streamSend('COPY', integration__integration_paths.IntegrationPaths.reflectEndpointUri, {transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = (yield _decodeStreamedResponseToJson(response));
        src__frontend__expect.expect(json[dartx._get]('method'), src__core_matchers.equals('COPY'));
      }, core.Null), VoidToFutureOfNull()));
      test.test('streamed custom HTTP method request with headers', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.streamSend('COPY', integration__integration_paths.IntegrationPaths.reflectEndpointUri, {headers: MapOfString$String().from(headers), transportPlatform: transportPlatform}));
        src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
        let json = (yield _decodeStreamedResponseToJson(response));
        src__frontend__expect.expect(json[dartx._get]('method'), src__core_matchers.equals('COPY'));
        src__frontend__expect.expect(json[dartx._get]('headers'), src__map_matchers.containsPair('authorization', headers[dartx._get]('authorization')));
        src__frontend__expect.expect(json[dartx._get]('headers'), src__map_matchers.containsPair('x-custom', headers[dartx._get]('x-custom')));
        src__frontend__expect.expect(json[dartx._get]('headers'), src__map_matchers.containsPair('x-tokens', headers[dartx._get]('x-tokens')));
      }, core.Null), VoidToFutureOfNull()));
      test.test('streamed custom HTTP method request with body', dart.fn(() => dart.async(function*() {
        let response = (yield src__http__http.Http.streamSend('COPY', integration__integration_paths.IntegrationPaths.echoEndpointUri, {body: 'body', transportPlatform: transportPlatform}));
        let body = (yield _decodeStreamedResponseToString(response));
        src__frontend__expect.expect(body, src__core_matchers.equals('body'));
      }, core.Null), VoidToFutureOfNull()));
    }, VoidToNull()));
  };
  dart.fn(integration__http__http_static__suite.runHttpStaticSuite, __Tovoid());
  dart.trackLibraries("test/test__shared_7", {
    "integration/http/http_static/suite.dart": integration__http__http_static__suite
  }, null);
  // Exports:
  return {
    integration__http__http_static__suite: integration__http__http_static__suite
  };
});
