define(['dart_sdk', 'test/test__shared_2', 'packages/test/lib__test', 'packages/w_transport/lib__shared_1', 'packages/w_transport/lib__shared_0', 'packages/matcher/lib__shared_0'], function(dart_sdk, test__shared_2, lib__test, lib__shared_1, lib__shared_0, lib__shared_0$) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const html = dart_sdk.html;
  const _interceptors = dart_sdk._interceptors;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const test = lib__test.test;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const src__http__browser__utils = lib__shared_1.src__http__browser__utils;
  const src__http__request_progress = lib__shared_0.src__http__request_progress;
  const src__core_matchers = lib__shared_0$.src__core_matchers;
  const unit__http__browser_utils_test = Object.create(null);
  let StreamOfProgressEvent = () => (StreamOfProgressEvent = dart.constFn(async.Stream$(html.ProgressEvent)))();
  let JSArrayOfProgressEvent = () => (JSArrayOfProgressEvent = dart.constFn(_interceptors.JSArray$(html.ProgressEvent)))();
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let StreamControllerOfProgressEvent = () => (StreamControllerOfProgressEvent = dart.constFn(async.StreamController$(html.ProgressEvent)))();
  let CompleterOfNull = () => (CompleterOfNull = dart.constFn(async.Completer$(core.Null)))();
  let ListOfEventTarget = () => (ListOfEventTarget = dart.constFn(core.List$(html.EventTarget)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let RequestProgressToNull = () => (RequestProgressToNull = dart.constFn(dart.fnType(core.Null, [src__http__request_progress.RequestProgress])))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let VoidTovoid = () => (VoidTovoid = dart.constFn(dart.fnType(dart.void, [])))();
  unit__http__browser_utils_test.main = function() {
    let naming = new naming$.Naming();
    naming.platform = naming$.platformBrowser;
    naming.testType = naming$.testTypeUnit;
    naming.topic = naming$.topicHttp;
    test.group(naming.toString(), dart.fn(() => {
      test.group('utils transformProgressEvents', dart.fn(() => {
        test.test('should convert computable ProgressEvents to WProgress instances with correct values', dart.fn(() => dart.async(function*() {
          let eventStream = StreamOfProgressEvent().fromIterable(JSArrayOfProgressEvent().of([new unit__http__browser_utils_test.MockProgressEvent.computable(0, 100), new unit__http__browser_utils_test.MockProgressEvent.computable(10, 100), new unit__http__browser_utils_test.MockProgressEvent.computable(50, 100), new unit__http__browser_utils_test.MockProgressEvent.computable(73, 100), new unit__http__browser_utils_test.MockProgressEvent.computable(100, 100)]));
          let requestProgressStream = eventStream.transform(src__http__request_progress.RequestProgress)(src__http__browser__utils.transformProgressEvents);
          let wEvents = (yield requestProgressStream.toList());
          src__frontend__expect.expect(wEvents[dartx._get](0).percent, src__core_matchers.equals(0.0));
          src__frontend__expect.expect(wEvents[dartx._get](1).percent, src__core_matchers.equals(10.0));
          src__frontend__expect.expect(wEvents[dartx._get](2).percent, src__core_matchers.equals(50.0));
          src__frontend__expect.expect(wEvents[dartx._get](3).percent, src__core_matchers.equals(73.0));
          src__frontend__expect.expect(wEvents[dartx._get](4).percent, src__core_matchers.equals(100.0));
        }, core.Null), VoidToFutureOfNull()));
        test.test('should convert non-computable ProgressEvents to WProgress instances with 0% values', dart.fn(() => dart.async(function*() {
          let events = StreamOfProgressEvent().fromIterable(JSArrayOfProgressEvent().of([new unit__http__browser_utils_test.MockProgressEvent.nonComputable(), new unit__http__browser_utils_test.MockProgressEvent.nonComputable()]));
          let wEventStream = events.transform(src__http__request_progress.RequestProgress)(src__http__browser__utils.transformProgressEvents);
          let wEvents = (yield wEventStream.toList());
          src__frontend__expect.expect(wEvents[dartx._get](0).percent, src__core_matchers.equals(0.0));
          src__frontend__expect.expect(wEvents[dartx._get](1).percent, src__core_matchers.equals(0.0));
        }, core.Null), VoidToFutureOfNull()));
        test.test('should support pausing and resuming a subscription', dart.fn(() => dart.async(function*() {
          let eventController = StreamControllerOfProgressEvent().new();
          let wEventStream = eventController.stream.transform(src__http__request_progress.RequestProgress)(src__http__browser__utils.transformProgressEvents);
          let c = CompleterOfNull().new();
          let eventCount = 0;
          let subscription = wEventStream.listen(dart.fn(_ => {
            eventCount++;
          }, RequestProgressToNull()), {onDone: dart.bind(c, 'complete')});
          eventController.add(new unit__http__browser_utils_test.MockProgressEvent.nonComputable());
          subscription.pause();
          eventController.add(new unit__http__browser_utils_test.MockProgressEvent.nonComputable());
          eventController.add(new unit__http__browser_utils_test.MockProgressEvent.nonComputable());
          subscription.resume();
          eventController.add(new unit__http__browser_utils_test.MockProgressEvent.nonComputable());
          yield eventController.close();
          yield c.future;
          src__frontend__expect.expect(eventCount, src__core_matchers.equals(4));
          yield subscription.cancel();
        }, core.Null), VoidToFutureOfNull()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  dart.fn(unit__http__browser_utils_test.main, VoidTovoid());
  const _initEvent = Symbol('_initEvent');
  const _selector = Symbol('_selector');
  const _get_currentTarget = Symbol('_get_currentTarget');
  const _get_target = Symbol('_get_target');
  unit__http__browser_utils_test.MockProgressEvent = class MockProgressEvent extends core.Object {
    get lengthComputable() {
      return this[lengthComputable];
    }
    set lengthComputable(value) {
      this[lengthComputable] = value;
    }
    get loaded() {
      return this[loaded$];
    }
    set loaded(value) {
      this[loaded$] = value;
    }
    get total() {
      return this[total$];
    }
    set total(value) {
      this[total$] = value;
    }
    computable(loaded, total) {
      this[loaded$] = loaded;
      this[total$] = total;
      this[lengthComputable] = true;
    }
    nonComputable() {
      this[lengthComputable] = false;
      this[loaded$] = null;
      this[total$] = null;
    }
    noSuchMethod(i) {
      return super.noSuchMethod(i);
    }
    _create_1(...args) {
      return html.ProgressEvent._check(this.noSuchMethod(new dart.InvocationImpl('_create_1', args, {isMethod: true})));
    }
    _create_2(...args) {
      return html.ProgressEvent._check(this.noSuchMethod(new dart.InvocationImpl('_create_2', args, {isMethod: true})));
    }
    deepPath(...args) {
      return ListOfEventTarget()._check(this.noSuchMethod(new dart.InvocationImpl(dartx.deepPath, args, {isMethod: true})));
    }
    [_initEvent](...args) {
      return dart.void._check(this.noSuchMethod(new dart.InvocationImpl(_initEvent, args, {isMethod: true})));
    }
    preventDefault(...args) {
      return dart.void._check(this.noSuchMethod(new dart.InvocationImpl(dartx.preventDefault, args, {isMethod: true})));
    }
    stopImmediatePropagation(...args) {
      return dart.void._check(this.noSuchMethod(new dart.InvocationImpl(dartx.stopImmediatePropagation, args, {isMethod: true})));
    }
    stopPropagation(...args) {
      return dart.void._check(this.noSuchMethod(new dart.InvocationImpl(dartx.stopPropagation, args, {isMethod: true})));
    }
    get matchingTarget() {
      return html.Element._check(this.noSuchMethod(new dart.InvocationImpl(dartx.matchingTarget, [], {isGetter: true})));
    }
    get currentTarget() {
      return html.EventTarget._check(this.noSuchMethod(new dart.InvocationImpl(dartx.currentTarget, [], {isGetter: true})));
    }
    get target() {
      return html.EventTarget._check(this.noSuchMethod(new dart.InvocationImpl(dartx.target, [], {isGetter: true})));
    }
    get [_selector]() {
      return core.String._check(this.noSuchMethod(new dart.InvocationImpl(_selector, [], {isGetter: true})));
    }
    set [_selector](args) {
      return dart.void._check(this.noSuchMethod(new dart.InvocationImpl(_selector, [args], {isSetter: true})));
    }
    get AT_TARGET() {
      return core.int._check(this.noSuchMethod(new dart.InvocationImpl('AT_TARGET', [], {isGetter: true})));
    }
    get BUBBLING_PHASE() {
      return core.int._check(this.noSuchMethod(new dart.InvocationImpl('BUBBLING_PHASE', [], {isGetter: true})));
    }
    get CAPTURING_PHASE() {
      return core.int._check(this.noSuchMethod(new dart.InvocationImpl('CAPTURING_PHASE', [], {isGetter: true})));
    }
    get bubbles() {
      return core.bool._check(this.noSuchMethod(new dart.InvocationImpl(dartx.bubbles, [], {isGetter: true})));
    }
    get cancelable() {
      return core.bool._check(this.noSuchMethod(new dart.InvocationImpl(dartx.cancelable, [], {isGetter: true})));
    }
    get [_get_currentTarget]() {
      return this.noSuchMethod(new dart.InvocationImpl(_get_currentTarget, [], {isGetter: true}));
    }
    get defaultPrevented() {
      return core.bool._check(this.noSuchMethod(new dart.InvocationImpl(dartx.defaultPrevented, [], {isGetter: true})));
    }
    get eventPhase() {
      return core.int._check(this.noSuchMethod(new dart.InvocationImpl(dartx.eventPhase, [], {isGetter: true})));
    }
    get isTrusted() {
      return core.bool._check(this.noSuchMethod(new dart.InvocationImpl(dartx.isTrusted, [], {isGetter: true})));
    }
    get path() {
      return ListOfEventTarget()._check(this.noSuchMethod(new dart.InvocationImpl(dartx.path, [], {isGetter: true})));
    }
    get scoped() {
      return core.bool._check(this.noSuchMethod(new dart.InvocationImpl(dartx.scoped, [], {isGetter: true})));
    }
    get [_get_target]() {
      return this.noSuchMethod(new dart.InvocationImpl(_get_target, [], {isGetter: true}));
    }
    get timeStamp() {
      return core.double._check(this.noSuchMethod(new dart.InvocationImpl(dartx.timeStamp, [], {isGetter: true})));
    }
    get type() {
      return core.String._check(this.noSuchMethod(new dart.InvocationImpl(dartx.type, [], {isGetter: true})));
    }
  };
  dart.defineNamedConstructor(unit__http__browser_utils_test.MockProgressEvent, 'computable');
  dart.defineNamedConstructor(unit__http__browser_utils_test.MockProgressEvent, 'nonComputable');
  const lengthComputable = Symbol("MockProgressEvent.lengthComputable");
  const loaded$ = Symbol("MockProgressEvent.loaded");
  const total$ = Symbol("MockProgressEvent.total");
  unit__http__browser_utils_test.MockProgressEvent[dart.implements] = () => [html.ProgressEvent];
  dart.setSignature(unit__http__browser_utils_test.MockProgressEvent, {
    fields: () => ({
      lengthComputable: dart.fieldType(core.bool),
      loaded: dart.fieldType(core.int),
      total: dart.fieldType(core.int)
    })
  });
  dart.defineExtensionMembers(unit__http__browser_utils_test.MockProgressEvent, [
    'lengthComputable',
    'loaded',
    'total',
    'deepPath',
    'preventDefault',
    'stopImmediatePropagation',
    'stopPropagation',
    'matchingTarget',
    'currentTarget',
    'target',
    'bubbles',
    'cancelable',
    'defaultPrevented',
    'eventPhase',
    'isTrusted',
    'path',
    'scoped',
    'timeStamp',
    'type'
  ]);
  dart.trackLibraries("test/test__unit__http__browser_utils_test", {
    "unit/http/browser_utils_test.dart": unit__http__browser_utils_test
  }, null);
  // Exports:
  return {
    unit__http__browser_utils_test: unit__http__browser_utils_test
  };
});
