define(['dart_sdk', 'test/test__shared_2', 'packages/test/lib__test', 'packages/w_transport/lib__w_transport', 'packages/matcher/lib__shared_0'], function(dart_sdk, test__shared_2, lib__test, lib__w_transport, lib__shared_0) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const _interceptors = dart_sdk._interceptors;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const test = lib__test.test;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const src__mocks__mock_transports = lib__w_transport.src__mocks__mock_transports;
  const src__http__http = lib__w_transport.src__http__http;
  const src__http__mock__response = lib__w_transport.src__http__mock__response;
  const src__http__finalized_request = lib__w_transport.src__http__finalized_request;
  const src__http__response = lib__w_transport.src__http__response;
  const src__http__http_body = lib__w_transport.src__http__http_body;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const unit__http__http_static_test = Object.create(null);
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let CompleterOfNull = () => (CompleterOfNull = dart.constFn(async.Completer$(core.Null)))();
  let FutureOfMockResponse = () => (FutureOfMockResponse = dart.constFn(async.Future$(src__http__mock__response.MockResponse)))();
  let FutureOfResponse = () => (FutureOfResponse = dart.constFn(async.Future$(src__http__response.Response)))();
  let JSArrayOfFutureOfResponse = () => (JSArrayOfFutureOfResponse = dart.constFn(_interceptors.JSArray$(FutureOfResponse())))();
  let CompleterOfString = () => (CompleterOfString = dart.constFn(async.Completer$(core.String)))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let FinalizedRequestToFutureOfMockResponse = () => (FinalizedRequestToFutureOfMockResponse = dart.constFn(dart.fnType(FutureOfMockResponse(), [src__http__finalized_request.FinalizedRequest])))();
  let VoidTovoid = () => (VoidTovoid = dart.constFn(dart.fnType(dart.void, [])))();
  unit__http__http_static_test.main = function() {
    let naming = new naming$.Naming();
    naming.testType = naming$.testTypeUnit;
    naming.topic = naming$.topicHttp;
    test.group(naming.toString(), dart.fn(() => {
      test.group('Http static methods', dart.fn(() => {
        let requestUri = core.Uri.parse('https://mock.com/resource?limit=10');
        test.setUp(dart.fn(() => {
          src__mocks__mock_transports.MockTransports.install();
        }, VoidToNull()));
        test.tearDown(dart.fn(() => dart.async(function*() {
          src__mocks__mock_transports.MockTransports.verifyNoOutstandingExceptions();
          yield src__mocks__mock_transports.MockTransports.uninstall();
        }, core.Null), VoidToFutureOfNull()));
        test.test('DELETE', dart.fn(() => dart.async(function*() {
          src__mocks__mock_transports.MockTransports.http.expect('DELETE', requestUri);
          yield src__http__http.Http.delete(requestUri);
        }, core.Null), VoidToFutureOfNull()));
        test.test('DELETE withCredentials', dart.fn(() => dart.async(function*() {
          let c = CompleterOfNull().new();
          src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(request => dart.async(function*(request) {
            if (dart.test(request.withCredentials)) {
              c.complete();
            } else {
              c.completeError('withCredentials should be true');
            }
            return src__http__mock__response.MockResponse.ok();
          }, src__http__mock__response.MockResponse, request), FinalizedRequestToFutureOfMockResponse()), {method: 'DELETE'});
          yield async.Future.wait(src__http__response.Response)(JSArrayOfFutureOfResponse().of([src__http__http.Http.delete(requestUri, {withCredentials: true}), c.future]));
        }, core.Null), VoidToFutureOfNull()));
        test.test('GET', dart.fn(() => dart.async(function*() {
          src__mocks__mock_transports.MockTransports.http.expect('GET', requestUri);
          yield src__http__http.Http.get(requestUri);
        }, core.Null), VoidToFutureOfNull()));
        test.test('GET withCredentials', dart.fn(() => dart.async(function*() {
          let c = CompleterOfNull().new();
          src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(request => dart.async(function*(request) {
            if (dart.test(request.withCredentials)) {
              c.complete();
            } else {
              c.completeError('withCredentials should be true');
            }
            return src__http__mock__response.MockResponse.ok();
          }, src__http__mock__response.MockResponse, request), FinalizedRequestToFutureOfMockResponse()), {method: 'GET'});
          yield async.Future.wait(src__http__response.Response)(JSArrayOfFutureOfResponse().of([src__http__http.Http.get(requestUri, {withCredentials: true}), c.future]));
        }, core.Null), VoidToFutureOfNull()));
        test.test('HEAD', dart.fn(() => dart.async(function*() {
          src__mocks__mock_transports.MockTransports.http.expect('HEAD', requestUri);
          yield src__http__http.Http.head(requestUri);
        }, core.Null), VoidToFutureOfNull()));
        test.test('HEAD withCredentials', dart.fn(() => dart.async(function*() {
          let c = CompleterOfNull().new();
          src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(request => dart.async(function*(request) {
            if (dart.test(request.withCredentials)) {
              c.complete();
            } else {
              c.completeError('withCredentials should be true');
            }
            return src__http__mock__response.MockResponse.ok();
          }, src__http__mock__response.MockResponse, request), FinalizedRequestToFutureOfMockResponse()), {method: 'HEAD'});
          yield async.Future.wait(src__http__response.Response)(JSArrayOfFutureOfResponse().of([src__http__http.Http.head(requestUri, {withCredentials: true}), c.future]));
        }, core.Null), VoidToFutureOfNull()));
        test.test('OPTIONS', dart.fn(() => dart.async(function*() {
          src__mocks__mock_transports.MockTransports.http.expect('OPTIONS', requestUri);
          yield src__http__http.Http.options(requestUri);
        }, core.Null), VoidToFutureOfNull()));
        test.test('OPTIONS withCredentials', dart.fn(() => dart.async(function*() {
          let c = CompleterOfNull().new();
          src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(request => dart.async(function*(request) {
            if (dart.test(request.withCredentials)) {
              c.complete();
            } else {
              c.completeError('withCredentials should be true');
            }
            return src__http__mock__response.MockResponse.ok();
          }, src__http__mock__response.MockResponse, request), FinalizedRequestToFutureOfMockResponse()), {method: 'OPTIONS'});
          yield async.Future.wait(src__http__response.Response)(JSArrayOfFutureOfResponse().of([src__http__http.Http.options(requestUri, {withCredentials: true}), c.future]));
        }, core.Null), VoidToFutureOfNull()));
        test.test('PATCH', dart.fn(() => dart.async(function*() {
          src__mocks__mock_transports.MockTransports.http.expect('PATCH', requestUri);
          yield src__http__http.Http.patch(requestUri);
        }, core.Null), VoidToFutureOfNull()));
        test.test('PATCH with body', dart.fn(() => dart.async(function*() {
          let c = CompleterOfString().new();
          src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(request => dart.async(function*(request) {
            let body = src__http__http_body.HttpBody._check(request.body);
            c.complete(body.asString());
            return src__http__mock__response.MockResponse.ok();
          }, src__http__mock__response.MockResponse, request), FinalizedRequestToFutureOfMockResponse()), {method: 'PATCH'});
          src__http__http.Http.patch(requestUri, {body: 'body'});
          src__frontend__expect.expect(yield c.future, src__core_matchers.equals('body'));
        }, core.Null), VoidToFutureOfNull()));
        test.test('PATCH withCredentials', dart.fn(() => dart.async(function*() {
          let c = CompleterOfNull().new();
          src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(request => dart.async(function*(request) {
            if (dart.test(request.withCredentials)) {
              c.complete();
            } else {
              c.completeError('withCredentials should be true');
            }
            return src__http__mock__response.MockResponse.ok();
          }, src__http__mock__response.MockResponse, request), FinalizedRequestToFutureOfMockResponse()), {method: 'PATCH'});
          yield async.Future.wait(src__http__response.Response)(JSArrayOfFutureOfResponse().of([src__http__http.Http.patch(requestUri, {withCredentials: true}), c.future]));
        }, core.Null), VoidToFutureOfNull()));
        test.test('POST', dart.fn(() => dart.async(function*() {
          src__mocks__mock_transports.MockTransports.http.expect('POST', requestUri);
          yield src__http__http.Http.post(requestUri);
        }, core.Null), VoidToFutureOfNull()));
        test.test('POST with body', dart.fn(() => dart.async(function*() {
          let c = CompleterOfString().new();
          src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(request => dart.async(function*(request) {
            let body = src__http__http_body.HttpBody._check(request.body);
            c.complete(body.asString());
            return src__http__mock__response.MockResponse.ok();
          }, src__http__mock__response.MockResponse, request), FinalizedRequestToFutureOfMockResponse()), {method: 'POST'});
          src__http__http.Http.post(requestUri, {body: 'body'});
          src__frontend__expect.expect(yield c.future, src__core_matchers.equals('body'));
        }, core.Null), VoidToFutureOfNull()));
        test.test('POST withCredentials', dart.fn(() => dart.async(function*() {
          let c = CompleterOfNull().new();
          src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(request => dart.async(function*(request) {
            if (dart.test(request.withCredentials)) {
              c.complete();
            } else {
              c.completeError('withCredentials should be true');
            }
            return src__http__mock__response.MockResponse.ok();
          }, src__http__mock__response.MockResponse, request), FinalizedRequestToFutureOfMockResponse()), {method: 'POST'});
          yield async.Future.wait(src__http__response.Response)(JSArrayOfFutureOfResponse().of([src__http__http.Http.post(requestUri, {withCredentials: true}), c.future]));
        }, core.Null), VoidToFutureOfNull()));
        test.test('PUT', dart.fn(() => dart.async(function*() {
          src__mocks__mock_transports.MockTransports.http.expect('PUT', requestUri);
          yield src__http__http.Http.put(requestUri);
        }, core.Null), VoidToFutureOfNull()));
        test.test('PUT with body', dart.fn(() => dart.async(function*() {
          let c = CompleterOfString().new();
          src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(request => dart.async(function*(request) {
            let body = src__http__http_body.HttpBody._check(request.body);
            c.complete(body.asString());
            return src__http__mock__response.MockResponse.ok();
          }, src__http__mock__response.MockResponse, request), FinalizedRequestToFutureOfMockResponse()), {method: 'PATCH'});
          src__http__http.Http.patch(requestUri, {body: 'body'});
          src__frontend__expect.expect(yield c.future, src__core_matchers.equals('body'));
        }, core.Null), VoidToFutureOfNull()));
        test.test('PUT withCredentials', dart.fn(() => dart.async(function*() {
          let c = CompleterOfNull().new();
          src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(request => dart.async(function*(request) {
            if (dart.test(request.withCredentials)) {
              c.complete();
            } else {
              c.completeError('withCredentials should be true');
            }
            return src__http__mock__response.MockResponse.ok();
          }, src__http__mock__response.MockResponse, request), FinalizedRequestToFutureOfMockResponse()), {method: 'PUT'});
          yield async.Future.wait(src__http__response.Response)(JSArrayOfFutureOfResponse().of([src__http__http.Http.put(requestUri, {withCredentials: true}), c.future]));
        }, core.Null), VoidToFutureOfNull()));
        test.test('custom method', dart.fn(() => dart.async(function*() {
          src__mocks__mock_transports.MockTransports.http.expect('COPY', requestUri);
          yield src__http__http.Http.send('COPY', requestUri);
        }, core.Null), VoidToFutureOfNull()));
        test.test('custom method with body', dart.fn(() => dart.async(function*() {
          let c = CompleterOfString().new();
          src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(request => dart.async(function*(request) {
            let body = src__http__http_body.HttpBody._check(request.body);
            c.complete(body.asString());
            return src__http__mock__response.MockResponse.ok();
          }, src__http__mock__response.MockResponse, request), FinalizedRequestToFutureOfMockResponse()), {method: 'COPY'});
          src__http__http.Http.send('COPY', requestUri, {body: 'body'});
          src__frontend__expect.expect(yield c.future, src__core_matchers.equals('body'));
        }, core.Null), VoidToFutureOfNull()));
        test.test('custom method withCredentials', dart.fn(() => dart.async(function*() {
          let c = CompleterOfNull().new();
          src__mocks__mock_transports.MockTransports.http.when(requestUri, dart.fn(request => dart.async(function*(request) {
            if (dart.test(request.withCredentials)) {
              c.complete();
            } else {
              c.completeError('withCredentials should be true');
            }
            return src__http__mock__response.MockResponse.ok();
          }, src__http__mock__response.MockResponse, request), FinalizedRequestToFutureOfMockResponse()), {method: 'COPY'});
          yield async.Future.wait(src__http__response.Response)(JSArrayOfFutureOfResponse().of([src__http__http.Http.send('COPY', requestUri, {withCredentials: true}), c.future]));
        }, core.Null), VoidToFutureOfNull()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  dart.fn(unit__http__http_static_test.main, VoidTovoid());
  dart.trackLibraries("test/test__unit__http__http_static_test", {
    "unit/http/http_static_test.dart": unit__http__http_static_test
  }, null);
  // Exports:
  return {
    unit__http__http_static_test: unit__http__http_static_test
  };
});
