define(['dart_sdk', 'test/test__shared_2', 'packages/test/lib__test', 'packages/w_transport/lib__w_transport', 'packages/matcher/lib__shared_0', 'packages/dart2_constant/lib__convert', 'packages/http_parser/lib__http_parser'], function(dart_sdk, test__shared_2, lib__test, lib__w_transport, lib__shared_0, lib__convert, lib__http_parser) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const _interceptors = dart_sdk._interceptors;
  const convert = dart_sdk.convert;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const test = lib__test.test;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const src__frontend__throws_matcher = lib__test.src__frontend__throws_matcher;
  const src__frontend__throws_matchers = lib__test.src__frontend__throws_matchers;
  const src__mocks__mock_transports = lib__w_transport.src__mocks__mock_transports;
  const src__http__requests = lib__w_transport.src__http__requests;
  const src__http__http_body = lib__w_transport.src__http__http_body;
  const src__http__mock__response = lib__w_transport.src__http__mock__response;
  const src__http__finalized_request = lib__w_transport.src__http__finalized_request;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const convert$ = lib__convert.convert;
  const src__media_type = lib__http_parser.src__media_type;
  const unit__http__json_request_test = Object.create(null);
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let MapOfString$String = () => (MapOfString$String = dart.constFn(core.Map$(core.String, core.String)))();
  let JSArrayOfMapOfString$String = () => (JSArrayOfMapOfString$String = dart.constFn(_interceptors.JSArray$(MapOfString$String())))();
  let isInstanceOfOfJsonUnsupportedObjectError = () => (isInstanceOfOfJsonUnsupportedObjectError = dart.constFn(src__core_matchers.isInstanceOf$(convert.JsonUnsupportedObjectError)))();
  let CompleterOfString = () => (CompleterOfString = dart.constFn(async.Completer$(core.String)))();
  let FutureOfMockResponse = () => (FutureOfMockResponse = dart.constFn(async.Future$(src__http__mock__response.MockResponse)))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let FinalizedRequestToFutureOfMockResponse = () => (FinalizedRequestToFutureOfMockResponse = dart.constFn(dart.fnType(FutureOfMockResponse(), [src__http__finalized_request.FinalizedRequest])))();
  let VoidTovoid = () => (VoidTovoid = dart.constFn(dart.fnType(dart.void, [])))();
  unit__http__json_request_test.main = function() {
    let naming = new naming$.Naming();
    naming.testType = naming$.testTypeUnit;
    naming.topic = naming$.topicHttp;
    test.group(naming.toString(), dart.fn(() => {
      test.group('JsonRequest', dart.fn(() => {
        test.setUp(dart.fn(() => {
          src__mocks__mock_transports.MockTransports.install();
        }, VoidToNull()));
        test.tearDown(dart.fn(() => dart.async(function*() {
          src__mocks__mock_transports.MockTransports.verifyNoOutstandingExceptions();
          yield src__mocks__mock_transports.MockTransports.uninstall();
        }, core.Null), VoidToFutureOfNull()));
        test.test('setting entire body (Map)', dart.fn(() => {
          let json = dart.map({field: 'value'}, core.String, core.String);
          let request = src__http__requests.JsonRequest.new();
          request.body = json;
          src__frontend__expect.expect(request.body, src__core_matchers.equals(json));
        }, VoidToNull()));
        test.test('setting entire body (List)', dart.fn(() => {
          let json = JSArrayOfMapOfString$String().of([dart.map({field: 'value'}, core.String, core.String)]);
          let request = src__http__requests.JsonRequest.new();
          request.body = json;
          src__frontend__expect.expect(request.body, src__core_matchers.equals(json));
        }, VoidToNull()));
        test.test('setting entire body (invalid JSON)', dart.fn(() => {
          let request = src__http__requests.JsonRequest.new();
          src__frontend__expect.expect(dart.fn(() => {
            request.body = async.Stream.fromIterable([]);
          }, VoidToNull()), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfJsonUnsupportedObjectError())()));
        }, VoidToNull()));
        test.test('setting fields incrementally', dart.fn(() => {
          let request = src__http__requests.FormRequest.new();
          request.fields[dartx._set]('field1', 'value1');
          request.fields[dartx._set]('field2', 'value2');
          src__frontend__expect.expect(request.fields, src__core_matchers.equals(dart.map({field1: 'value1', field2: 'value2'}, core.String, core.String)));
        }, VoidToNull()));
        test.test('setting body in request dispatcher is supported (Map)', dart.fn(() => dart.async(function*() {
          let uri = core.Uri.parse('/test');
          let c = CompleterOfString().new();
          src__mocks__mock_transports.MockTransports.http.when(uri, dart.fn(request => dart.async(function*(request) {
            let body = src__http__http_body.HttpBody._check(request.body);
            c.complete(body.asString());
            return src__http__mock__response.MockResponse.ok();
          }, src__http__mock__response.MockResponse, request), FinalizedRequestToFutureOfMockResponse()));
          let request = src__http__requests.JsonRequest.new();
          let json = dart.map({field: 'value'}, core.String, core.String);
          yield request.post({uri: uri, body: json});
          src__frontend__expect.expect(yield c.future, src__core_matchers.equals(convert$.json.encode(json)));
        }, core.Null), VoidToFutureOfNull()));
        test.test('setting body in request dispatcher is supported (List)', dart.fn(() => dart.async(function*() {
          let uri = core.Uri.parse('/test');
          let c = CompleterOfString().new();
          src__mocks__mock_transports.MockTransports.http.when(uri, dart.fn(request => dart.async(function*(request) {
            let body = src__http__http_body.HttpBody._check(request.body);
            c.complete(body.asString());
            return src__http__mock__response.MockResponse.ok();
          }, src__http__mock__response.MockResponse, request), FinalizedRequestToFutureOfMockResponse()));
          let request = src__http__requests.JsonRequest.new();
          let json = JSArrayOfMapOfString$String().of([dart.map({field: 'value'}, core.String, core.String)]);
          yield request.post({uri: uri, body: json});
          src__frontend__expect.expect(yield c.future, src__core_matchers.equals(convert$.json.encode(json)));
        }, core.Null), VoidToFutureOfNull()));
        test.test('setting body in request dispatcher should throw if invalid', dart.fn(() => dart.async(function*() {
          let uri = core.Uri.parse('/test');
          let request = src__http__requests.JsonRequest.new();
          src__frontend__expect.expect(request.post({uri: uri, body: convert$.utf8}), src__frontend__throws_matcher.throwsA(new (isInstanceOfOfJsonUnsupportedObjectError())()));
        }, core.Null), VoidToFutureOfNull()));
        test.test('body should be unmodifiable once sent', dart.fn(() => dart.async(function*() {
          let uri = core.Uri.parse('/test');
          src__mocks__mock_transports.MockTransports.http.expect('POST', uri);
          let request = src__http__requests.JsonRequest.new();
          yield request.post({uri: uri});
          src__frontend__expect.expect(dart.fn(() => {
            request.body = dart.map({too: 'late'}, core.String, core.String);
          }, VoidToNull()), src__frontend__throws_matchers.throwsStateError);
        }, core.Null), VoidToFutureOfNull()));
        test.test('content-length cannot be set manually', dart.fn(() => {
          let request = src__http__requests.Request.new();
          src__frontend__expect.expect(dart.fn(() => {
            request.contentLength = 10;
          }, VoidToNull()), src__frontend__throws_matchers.throwsUnsupportedError);
        }, VoidToNull()));
        test.test('setting encoding to null should throw', dart.fn(() => {
          let request = src__http__requests.JsonRequest.new();
          src__frontend__expect.expect(dart.fn(() => {
            request.encoding = null;
          }, VoidToNull()), src__frontend__throws_matchers.throwsArgumentError);
        }, VoidToNull()));
        test.test('setting encoding should update content-type', dart.fn(() => {
          let request = src__http__requests.JsonRequest.new();
          src__frontend__expect.expect(request.contentType.parameters[dartx._get]('charset'), src__core_matchers.equals(convert$.utf8.name));
          request.encoding = convert$.latin1;
          src__frontend__expect.expect(request.contentType.parameters[dartx._get]('charset'), src__core_matchers.equals(convert$.latin1.name));
          request.encoding = convert$.ascii;
          src__frontend__expect.expect(request.contentType.parameters[dartx._get]('charset'), src__core_matchers.equals(convert$.ascii.name));
        }, VoidToNull()));
        test.test('setting encoding should not update content-type if content-type has been set manually', dart.fn(() => {
          let request = src__http__requests.JsonRequest.new();
          src__frontend__expect.expect(request.contentType.parameters[dartx._get]('charset'), src__core_matchers.equals(convert$.utf8.name));
          request.contentType = new src__media_type.MediaType('application', 'x-custom', dart.map({charset: convert$.latin1.name}, core.String, core.String));
          src__frontend__expect.expect(request.contentType.mimeType, src__core_matchers.equals('application/x-custom'));
          src__frontend__expect.expect(request.contentType.parameters[dartx._get]('charset'), src__core_matchers.equals(convert$.latin1.name));
          request.encoding = convert$.ascii;
          src__frontend__expect.expect(request.contentType.parameters[dartx._get]('charset'), src__core_matchers.equals(convert$.latin1.name));
        }, VoidToNull()));
        test.test('setting content-type should not be allowed once sent', dart.fn(() => dart.async(function*() {
          let uri = core.Uri.parse('/test');
          src__mocks__mock_transports.MockTransports.http.expect('GET', uri);
          let request = src__http__requests.JsonRequest.new();
          yield request.get({uri: uri});
          src__frontend__expect.expect(dart.fn(() => {
            request.contentType = new src__media_type.MediaType('application', 'x-custom');
          }, VoidToNull()), src__frontend__throws_matchers.throwsStateError);
        }, core.Null), VoidToFutureOfNull()));
        test.test('setting encoding should not be allowed once sent', dart.fn(() => dart.async(function*() {
          let uri = core.Uri.parse('/test');
          src__mocks__mock_transports.MockTransports.http.expect('GET', uri);
          let request = src__http__requests.JsonRequest.new();
          yield request.get({uri: uri});
          src__frontend__expect.expect(dart.fn(() => {
            request.encoding = convert$.latin1;
          }, VoidToNull()), src__frontend__throws_matchers.throwsStateError);
        }, core.Null), VoidToFutureOfNull()));
        test.test('custom content-type without inferrable encoding', dart.fn(() => dart.async(function*() {
          let uri = core.Uri.parse('/test');
          src__mocks__mock_transports.MockTransports.http.expect('POST', uri);
          let request = src__http__requests.JsonRequest.new();
          request.contentType = new src__media_type.MediaType('application', 'x-custom');
          request.body = dart.map({foo: 'bar'}, core.String, core.String);
          yield request.post({uri: uri});
        }, core.Null), VoidToFutureOfNull()));
        test.test('clone()', dart.fn(() => {
          let body = JSArrayOfMapOfString$String().of([dart.map({f1: 'v1', f2: 'v2'}, core.String, core.String)]);
          let orig = src__http__requests.JsonRequest.new();
          orig.body = body;
          let clone = orig.clone();
          src__frontend__expect.expect(clone.body, src__core_matchers.equals(body));
        }, VoidToNull()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  dart.fn(unit__http__json_request_test.main, VoidTovoid());
  dart.trackLibraries("test/test__unit__http__json_request_test", {
    "unit/http/json_request_test.dart": unit__http__json_request_test
  }, null);
  // Exports:
  return {
    unit__http__json_request_test: unit__http__json_request_test
  };
});
