define(['dart_sdk', 'test/test__shared_2', 'packages/test/lib__test', 'packages/http_parser/lib__http_parser', 'packages/w_transport/lib__shared_0', 'packages/matcher/lib__shared_0'], function(dart_sdk, test__shared_2, lib__test, lib__http_parser, lib__shared_0, lib__shared_0$) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const _interceptors = dart_sdk._interceptors;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const test = lib__test.test;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const src__media_type = lib__http_parser.src__media_type;
  const src__http__multipart_file = lib__shared_0.src__http__multipart_file;
  const src__core_matchers = lib__shared_0$.src__core_matchers;
  const unit__http__multipart_file_test = Object.create(null);
  let ListOfint = () => (ListOfint = dart.constFn(core.List$(core.int)))();
  let StreamOfListOfint = () => (StreamOfListOfint = dart.constFn(async.Stream$(ListOfint())))();
  let JSArrayOfListOfint = () => (JSArrayOfListOfint = dart.constFn(_interceptors.JSArray$(ListOfint())))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let VoidTovoid = () => (VoidTovoid = dart.constFn(dart.fnType(dart.void, [])))();
  unit__http__multipart_file_test.main = function() {
    let naming = new naming$.Naming();
    naming.testType = naming$.testTypeUnit;
    naming.topic = naming$.topicHttp;
    test.group(naming.toString(), dart.fn(() => {
      test.group('MultipartFile', dart.fn(() => {
        test.test('content-type set explicitly', dart.fn(() => {
          let contentType = new src__media_type.MediaType('application', 'json');
          let file = new src__http__multipart_file.MultipartFile(StreamOfListOfint().fromIterable(JSArrayOfListOfint().of([])), 0, {contentType: contentType, filename: 'page.html'});
          src__frontend__expect.expect(file.contentType.mimeType, 'application/json');
        }, VoidToNull()));
        test.test('content-type should be based on a mimetype lookup', dart.fn(() => {
          let stream = StreamOfListOfint().fromIterable(JSArrayOfListOfint().of([]));
          let jsonFile = new src__http__multipart_file.MultipartFile(stream, 0, {filename: 'data.json'});
          src__frontend__expect.expect(jsonFile.contentType.mimeType, src__core_matchers.equals('application/json'));
          let zipFile = new src__http__multipart_file.MultipartFile(stream, 0, {filename: 'compressed.zip'});
          src__frontend__expect.expect(zipFile.contentType.mimeType, src__core_matchers.equals('application/zip'));
          let imgFile = new src__http__multipart_file.MultipartFile(stream, 0, {filename: 'img.png'});
          src__frontend__expect.expect(imgFile.contentType.mimeType, src__core_matchers.equals('image/png'));
          let htmlFile = new src__http__multipart_file.MultipartFile(stream, 0, {filename: 'page.html'});
          src__frontend__expect.expect(htmlFile.contentType.mimeType, src__core_matchers.equals('text/html'));
        }, VoidToNull()));
        test.test('content-type default to application/octet-stream', dart.fn(() => {
          let file = new src__http__multipart_file.MultipartFile(StreamOfListOfint().fromIterable(JSArrayOfListOfint().of([])), 0);
          src__frontend__expect.expect(file.contentType.mimeType, src__core_matchers.equals('application/octet-stream'));
        }, VoidToNull()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  dart.fn(unit__http__multipart_file_test.main, VoidTovoid());
  dart.trackLibraries("test/test__unit__http__multipart_file_test", {
    "unit/http/multipart_file_test.dart": unit__http__multipart_file_test
  }, null);
  // Exports:
  return {
    unit__http__multipart_file_test: unit__http__multipart_file_test
  };
});
