define(['dart_sdk', 'test/test__shared_2', 'packages/test/lib__test', 'packages/dart2_constant/lib__convert', 'packages/http_parser/lib__http_parser', 'packages/w_transport/lib__shared_0', 'packages/matcher/lib__shared_0'], function(dart_sdk, test__shared_2, lib__test, lib__convert, lib__http_parser, lib__shared_0, lib__shared_0$) {
  'use strict';
  const core = dart_sdk.core;
  const typed_data = dart_sdk.typed_data;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const test = lib__test.test;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const convert = lib__convert.convert;
  const src__media_type = lib__http_parser.src__media_type;
  const src__http__response_format_exception = lib__shared_0.src__http__response_format_exception;
  const src__core_matchers = lib__shared_0$.src__core_matchers;
  const unit__http__response_format_exception_test = Object.create(null);
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let VoidTovoid = () => (VoidTovoid = dart.constFn(dart.fnType(dart.void, [])))();
  unit__http__response_format_exception_test.main = function() {
    let naming = new naming$.Naming();
    naming.testType = naming$.testTypeUnit;
    naming.topic = naming$.topicHttp;
    test.group(naming.toString(), dart.fn(() => {
      test.group('ResponseFormatException', dart.fn(() => {
        test.test('should detail why bytes could not be decoded', dart.fn(() => {
          let bytes = convert.utf8.encode('bodyçå®');
          let contentType = new src__media_type.MediaType('application', 'json', dart.map({charset: convert.ascii.name}, core.String, core.String));
          let exception = new src__http__response_format_exception.ResponseFormatException(contentType, convert.ascii, {bytes: typed_data.Uint8List._check(bytes)});
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains('Bytes could not be decoded'));
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains(dart.str`Content-Type: ${contentType}`));
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains(dart.str`Encoding: ${convert.ascii.name}`));
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains(dart.toString(convert.utf8.encode('bodyçå®'))));
        }, VoidToNull()));
        test.test('should detail why string could not be encoded', dart.fn(() => {
          let body = 'bodyçå®';
          let contentType = new src__media_type.MediaType('application', 'json', dart.map({charset: convert.ascii.name}, core.String, core.String));
          let exception = new src__http__response_format_exception.ResponseFormatException(contentType, convert.ascii, {body: body});
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains('Body could not be encoded'));
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains(dart.str`Content-Type: ${contentType}`));
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains(dart.str`Encoding: ${convert.ascii.name}`));
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains('bodyçå®'));
        }, VoidToNull()));
        test.test('should warn if encoding is null', dart.fn(() => {
          let body = 'bodyçå®';
          let contentType = new src__media_type.MediaType('application', 'json', dart.map({charset: convert.ascii.name}, core.String, core.String));
          let exception = new src__http__response_format_exception.ResponseFormatException(contentType, null, {body: body});
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains('Body could not be encoded'));
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains(dart.str`Content-Type: ${contentType}`));
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains('Encoding: null'));
          src__frontend__expect.expect(exception.toString(), src__core_matchers.contains('bodyçå®'));
        }, VoidToNull()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  dart.fn(unit__http__response_format_exception_test.main, VoidTovoid());
  dart.trackLibraries("test/test__unit__http__response_format_exception_test", {
    "unit/http/response_format_exception_test.dart": unit__http__response_format_exception_test
  }, null);
  // Exports:
  return {
    unit__http__response_format_exception_test: unit__http__response_format_exception_test
  };
});
