define(['dart_sdk', 'test/test__shared_2', 'packages/test/lib__test', 'packages/w_transport/lib__w_transport', 'packages/matcher/lib__shared_0', 'packages/dart2_constant/lib__convert'], function(dart_sdk, test__shared_2, lib__test, lib__w_transport, lib__shared_0, lib__convert) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const _interceptors = dart_sdk._interceptors;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const test = lib__test.test;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const src__frontend__throws_matchers = lib__test.src__frontend__throws_matchers;
  const src__http__mock__response = lib__w_transport.src__http__mock__response;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const src__map_matchers = lib__shared_0.src__map_matchers;
  const convert = lib__convert.convert;
  const unit__mocks__mock_response_test = Object.create(null);
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let JSArrayOfint = () => (JSArrayOfint = dart.constFn(_interceptors.JSArray$(core.int)))();
  let ListOfint = () => (ListOfint = dart.constFn(core.List$(core.int)))();
  let StreamOfListOfint = () => (StreamOfListOfint = dart.constFn(async.Stream$(ListOfint())))();
  let JSArrayOfListOfint = () => (JSArrayOfListOfint = dart.constFn(_interceptors.JSArray$(ListOfint())))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let StringToStreamOfListOfint = () => (StringToStreamOfListOfint = dart.constFn(dart.fnType(StreamOfListOfint(), [core.String])))();
  let VoidTovoid = () => (VoidTovoid = dart.constFn(dart.fnType(dart.void, [])))();
  unit__mocks__mock_response_test.main = function() {
    let naming = new naming$.Naming();
    naming.testType = naming$.testTypeUnit;
    naming.topic = naming$.topicMocks;
    test.group(naming.toString(), dart.fn(() => {
      test.group('MockResponse', dart.fn(() => {
        test.test('custom constructor', dart.fn(() => dart.async(function*() {
          let response = new src__http__mock__response.MockResponse(100, {statusText: 'custom', headers: dart.map({'x-custom': 'value'}, core.String, core.String), body: 'data'});
          src__frontend__expect.expect(response.status, src__core_matchers.equals(100));
          src__frontend__expect.expect(response.statusText, src__core_matchers.equals('custom'));
          src__frontend__expect.expect(response.headers[dartx._get]('x-custom'), src__core_matchers.equals('value'));
          src__frontend__expect.expect(response.body.asString(), src__core_matchers.equals('data'));
        }, core.Null), VoidToFutureOfNull()));
        test.test('.ok() 200', dart.fn(() => {
          let response = src__http__mock__response.MockResponse.ok();
          src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
          src__frontend__expect.expect(response.statusText, src__core_matchers.equals('OK'));
        }, VoidToNull()));
        test.test('.badRequest() 400', dart.fn(() => {
          let response = src__http__mock__response.MockResponse.badRequest();
          src__frontend__expect.expect(response.status, src__core_matchers.equals(400));
          src__frontend__expect.expect(response.statusText, src__core_matchers.equals('BAD REQUEST'));
        }, VoidToNull()));
        test.test('.unauthorized() 401', dart.fn(() => {
          let response = src__http__mock__response.MockResponse.unauthorized();
          src__frontend__expect.expect(response.status, src__core_matchers.equals(401));
          src__frontend__expect.expect(response.statusText, src__core_matchers.equals('UNAUTHORIZED'));
        }, VoidToNull()));
        test.test('.forbidden() 403', dart.fn(() => {
          let response = src__http__mock__response.MockResponse.forbidden();
          src__frontend__expect.expect(response.status, src__core_matchers.equals(403));
          src__frontend__expect.expect(response.statusText, src__core_matchers.equals('FORBIDDEN'));
        }, VoidToNull()));
        test.test('.notFound() 404', dart.fn(() => {
          let response = src__http__mock__response.MockResponse.notFound();
          src__frontend__expect.expect(response.status, src__core_matchers.equals(404));
          src__frontend__expect.expect(response.statusText, src__core_matchers.equals('NOT FOUND'));
        }, VoidToNull()));
        test.test('.methodNotAllowed() 405', dart.fn(() => {
          let response = src__http__mock__response.MockResponse.methodNotAllowed();
          src__frontend__expect.expect(response.status, src__core_matchers.equals(405));
          src__frontend__expect.expect(response.statusText, src__core_matchers.equals('METHOD NOT ALLOWED'));
        }, VoidToNull()));
        test.test('.internalServerError() 500', dart.fn(() => {
          let response = src__http__mock__response.MockResponse.internalServerError();
          src__frontend__expect.expect(response.status, src__core_matchers.equals(500));
          src__frontend__expect.expect(response.statusText, src__core_matchers.equals('INTERNAL SERVER ERROR'));
        }, VoidToNull()));
        test.test('.notImplemented() 501', dart.fn(() => {
          let response = src__http__mock__response.MockResponse.notImplemented();
          src__frontend__expect.expect(response.status, src__core_matchers.equals(501));
          src__frontend__expect.expect(response.statusText, src__core_matchers.equals('NOT IMPLEMENTED'));
        }, VoidToNull()));
        test.test('.badGateway() 502', dart.fn(() => {
          let response = src__http__mock__response.MockResponse.badGateway();
          src__frontend__expect.expect(response.status, src__core_matchers.equals(502));
          src__frontend__expect.expect(response.statusText, src__core_matchers.equals('BAD GATEWAY'));
        }, VoidToNull()));
        test.test('encoding should set charset', dart.fn(() => {
          let response = new src__http__mock__response.MockResponse(200, {encoding: convert.ascii});
          src__frontend__expect.expect(response.contentType.parameters[dartx._get]('charset'), src__core_matchers.equals(convert.ascii.name));
        }, VoidToNull()));
        test.test('should support string body', dart.fn(() => {
          let response = new src__http__mock__response.MockResponse(200, {body: 'body'});
          src__frontend__expect.expect(response.body.asString(), src__core_matchers.equals('body'));
        }, VoidToNull()));
        test.test('should support bytes body', dart.fn(() => {
          let response = new src__http__mock__response.MockResponse(200, {body: convert.utf8.encode('body')});
          src__frontend__expect.expect(response.body.asString(), src__core_matchers.equals('body'));
        }, VoidToNull()));
        test.test('should throw on invalid body', dart.fn(() => {
          src__frontend__expect.expect(dart.fn(() => {
            new src__http__mock__response.MockResponse(200, {body: dart.map({invalid: 'map'}, core.String, core.String)});
          }, VoidToNull()), src__frontend__throws_matchers.throwsArgumentError);
        }, VoidToNull()));
        test.test('content-length', dart.fn(() => {
          let response = src__http__mock__response.MockResponse.ok({body: JSArrayOfint().of([1, 2])});
          src__frontend__expect.expect(response.contentLength, src__core_matchers.equals(2));
        }, VoidToNull()));
        test.test('content-type', dart.fn(() => {
          let response = src__http__mock__response.MockResponse.ok({headers: dart.map({'content-type': 'application/json; charset=utf-8'}, core.String, core.String)});
          src__frontend__expect.expect(response.contentType.mimeType, src__core_matchers.equals('application/json'));
          src__frontend__expect.expect(response.contentType.parameters, src__map_matchers.containsPair('charset', 'utf-8'));
        }, VoidToNull()));
        test.test('replace', dart.fn(() => {
          let response = src__http__mock__response.MockResponse.ok();
          let response2 = response.replace({status: 201});
          src__frontend__expect.expect(response2.status, src__core_matchers.equals(201));
        }, VoidToNull()));
      }, VoidToNull()));
      test.group('MockStreamedResponse', dart.fn(() => {
        function toByteStream(body) {
          return StreamOfListOfint().fromIterable(JSArrayOfListOfint().of([convert.utf8.encode(body)]));
        }
        dart.fn(toByteStream, StringToStreamOfListOfint());
        test.test('custom constructor', dart.fn(() => dart.async(function*() {
          let response = new src__http__mock__response.MockStreamedResponse(100, {statusText: 'custom', headers: dart.map({'x-custom': 'value'}, core.String, core.String), byteStream: toByteStream('data')});
          src__frontend__expect.expect(response.status, src__core_matchers.equals(100));
          src__frontend__expect.expect(response.statusText, src__core_matchers.equals('custom'));
          src__frontend__expect.expect(response.headers[dartx._get]('x-custom'), src__core_matchers.equals('value'));
          src__frontend__expect.expect(convert.utf8.decode(yield response.body.toBytes()), src__core_matchers.equals('data'));
        }, core.Null), VoidToFutureOfNull()));
        test.test('.ok() 200', dart.fn(() => {
          let response = src__http__mock__response.MockStreamedResponse.ok();
          src__frontend__expect.expect(response.status, src__core_matchers.equals(200));
          src__frontend__expect.expect(response.statusText, src__core_matchers.equals('OK'));
        }, VoidToNull()));
        test.test('.badRequest() 400', dart.fn(() => {
          let response = src__http__mock__response.MockStreamedResponse.badRequest();
          src__frontend__expect.expect(response.status, src__core_matchers.equals(400));
          src__frontend__expect.expect(response.statusText, src__core_matchers.equals('BAD REQUEST'));
        }, VoidToNull()));
        test.test('.unauthorized() 401', dart.fn(() => {
          let response = src__http__mock__response.MockStreamedResponse.unauthorized();
          src__frontend__expect.expect(response.status, src__core_matchers.equals(401));
          src__frontend__expect.expect(response.statusText, src__core_matchers.equals('UNAUTHORIZED'));
        }, VoidToNull()));
        test.test('.forbidden() 403', dart.fn(() => {
          let response = src__http__mock__response.MockStreamedResponse.forbidden();
          src__frontend__expect.expect(response.status, src__core_matchers.equals(403));
          src__frontend__expect.expect(response.statusText, src__core_matchers.equals('FORBIDDEN'));
        }, VoidToNull()));
        test.test('.notFound() 404', dart.fn(() => {
          let response = src__http__mock__response.MockStreamedResponse.notFound();
          src__frontend__expect.expect(response.status, src__core_matchers.equals(404));
          src__frontend__expect.expect(response.statusText, src__core_matchers.equals('NOT FOUND'));
        }, VoidToNull()));
        test.test('.methodNotAllowed() 405', dart.fn(() => {
          let response = src__http__mock__response.MockStreamedResponse.methodNotAllowed();
          src__frontend__expect.expect(response.status, src__core_matchers.equals(405));
          src__frontend__expect.expect(response.statusText, src__core_matchers.equals('METHOD NOT ALLOWED'));
        }, VoidToNull()));
        test.test('.internalServerError() 500', dart.fn(() => {
          let response = src__http__mock__response.MockStreamedResponse.internalServerError();
          src__frontend__expect.expect(response.status, src__core_matchers.equals(500));
          src__frontend__expect.expect(response.statusText, src__core_matchers.equals('INTERNAL SERVER ERROR'));
        }, VoidToNull()));
        test.test('.notImplemented() 501', dart.fn(() => {
          let response = src__http__mock__response.MockStreamedResponse.notImplemented();
          src__frontend__expect.expect(response.status, src__core_matchers.equals(501));
          src__frontend__expect.expect(response.statusText, src__core_matchers.equals('NOT IMPLEMENTED'));
        }, VoidToNull()));
        test.test('.badGateway() 502', dart.fn(() => {
          let response = src__http__mock__response.MockStreamedResponse.badGateway();
          src__frontend__expect.expect(response.status, src__core_matchers.equals(502));
          src__frontend__expect.expect(response.statusText, src__core_matchers.equals('BAD GATEWAY'));
        }, VoidToNull()));
        test.test('encoding should set charset', dart.fn(() => {
          let response = new src__http__mock__response.MockStreamedResponse(200, {encoding: convert.ascii});
          src__frontend__expect.expect(response.contentType.parameters[dartx._get]('charset'), src__core_matchers.equals(convert.ascii.name));
        }, VoidToNull()));
        test.test('should support byteStream body', dart.fn(() => dart.async(function*() {
          let response = new src__http__mock__response.MockStreamedResponse(200, {byteStream: toByteStream('body')});
          src__frontend__expect.expect(convert.utf8.decode(yield response.body.toBytes()), src__core_matchers.equals('body'));
        }, core.Null), VoidToFutureOfNull()));
        test.test('content-length', dart.fn(() => {
          let response = src__http__mock__response.MockStreamedResponse.ok({headers: dart.map({'content-length': '5'}, core.String, core.String)});
          src__frontend__expect.expect(response.contentLength, src__core_matchers.equals(5));
        }, VoidToNull()));
        test.test('content-type', dart.fn(() => {
          let response = src__http__mock__response.MockStreamedResponse.ok({headers: dart.map({'content-type': 'application/json; charset=utf-8'}, core.String, core.String)});
          src__frontend__expect.expect(response.contentType.mimeType, src__core_matchers.equals('application/json'));
          src__frontend__expect.expect(response.contentType.parameters, src__map_matchers.containsPair('charset', 'utf-8'));
        }, VoidToNull()));
        test.test('encoding', dart.fn(() => {
          let response = new src__http__mock__response.MockStreamedResponse(200, {encoding: convert.utf8});
          src__frontend__expect.expect(response.encoding, src__core_matchers.equals(convert.utf8));
        }, VoidToNull()));
        test.test('replace', dart.fn(() => {
          let response = src__http__mock__response.MockStreamedResponse.ok();
          let response2 = response.replace({status: 201});
          src__frontend__expect.expect(response2.status, src__core_matchers.equals(201));
        }, VoidToNull()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  dart.fn(unit__mocks__mock_response_test.main, VoidTovoid());
  dart.trackLibraries("test/test__unit__mocks__mock_response_test", {
    "unit/mocks/mock_response_test.dart": unit__mocks__mock_response_test
  }, null);
  // Exports:
  return {
    unit__mocks__mock_response_test: unit__mocks__mock_response_test
  };
});
