define(['dart_sdk', 'test/test__shared_2', 'packages/test/lib__test', 'packages/w_transport/lib__shared_0', 'packages/matcher/lib__shared_0', 'packages/mockito/lib__shared_0'], function(dart_sdk, test__shared_2, lib__test, lib__shared_0, lib__shared_0$, lib__shared_0$0) {
  'use strict';
  const core = dart_sdk.core;
  const async = dart_sdk.async;
  const _interceptors = dart_sdk._interceptors;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const naming$ = test__shared_2.naming;
  const test = lib__test.test;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const src__web_socket__w_socket_subscription = lib__shared_0.src__web_socket__w_socket_subscription;
  const src__core_matchers = lib__shared_0$.src__core_matchers;
  const src__mock = lib__shared_0$0.src__mock;
  const unit__ws__w_socket_subscription_test = Object.create(null);
  let CompleterOfNull = () => (CompleterOfNull = dart.constFn(async.Completer$(core.Null)))();
  let JSArrayOfFuture = () => (JSArrayOfFuture = dart.constFn(_interceptors.JSArray$(async.Future)))();
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let VoidTovoid = () => (VoidTovoid = dart.constFn(dart.fnTypeFuzzy(dart.void, [])))();
  let MockStreamSubscription = () => (MockStreamSubscription = dart.constFn(unit__ws__w_socket_subscription_test.MockStreamSubscription$()))();
  let dynamicToNull = () => (dynamicToNull = dart.constFn(dart.fnType(core.Null, [dart.dynamic])))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let VoidTovoid$ = () => (VoidTovoid$ = dart.constFn(dart.fnType(dart.void, [])))();
  unit__ws__w_socket_subscription_test.main = function() {
    let naming = new naming$.Naming();
    naming.testType = naming$.testTypeUnit;
    naming.topic = naming$.topicWebSocket;
    test.group(naming.toString(), dart.fn(() => {
      test.group('WSocketSubscription', dart.fn(() => {
        test.test('cancel() should cancel underlying subscription and call callback', dart.fn(() => dart.async(function*() {
          let onCancelCalled = CompleterOfNull().new();
          let sc = async.StreamController.new();
          let sub = sc.stream.listen(dart.fn(_ => {
          }, dynamicToNull()));
          let wsub = new src__web_socket__w_socket_subscription.WSocketSubscription(sub, dart.fn(() => {
          }, VoidToNull()), {onCancel: dart.bind(onCancelCalled, 'complete')});
          yield async.Future.wait(dart.dynamic)(JSArrayOfFuture().of([wsub.cancel(), onCancelCalled.future]));
          yield sc.close();
          yield sub.cancel();
        }, core.Null), VoidToFutureOfNull()));
        test.test('isPaused should return the status of the underlying subscription', dart.fn(() => dart.async(function*() {
          let sc = async.StreamController.new();
          let sub = sc.stream.listen(dart.fn(_ => {
          }, dynamicToNull()));
          let wsub = new src__web_socket__w_socket_subscription.WSocketSubscription(sub, dart.fn(() => {
          }, VoidToNull()));
          src__frontend__expect.expect(sub.isPaused, src__core_matchers.isFalse);
          src__frontend__expect.expect(wsub.isPaused, src__core_matchers.isFalse);
          sub.pause();
          src__frontend__expect.expect(sub.isPaused, src__core_matchers.isTrue);
          src__frontend__expect.expect(wsub.isPaused, src__core_matchers.isTrue);
          sub.resume();
          yield async.Future.wait(dart.dynamic)(JSArrayOfFuture().of([sc.close(), sub.cancel(), wsub.cancel()]));
        }, core.Null), VoidToFutureOfNull()));
        test.test('onDone() should update the done handler', dart.fn(() => dart.async(function*() {
          let sub = new unit__ws__w_socket_subscription_test.MockStreamSubscription();
          let wsub = new src__web_socket__w_socket_subscription.WSocketSubscription(sub, dart.fn(() => {
          }, VoidToNull()));
          let doneHandler = dart.fn(() => {
          }, VoidToNull());
          wsub.onDone(doneHandler);
          src__frontend__expect.expect(wsub.doneHandler, src__core_matchers.equals(doneHandler));
          yield wsub.cancel();
          yield sub.cancel();
        }, core.Null), VoidToFutureOfNull()));
        test.test('onError() should call onError() on the underlying subscription', dart.fn(() => dart.async(function*() {
          let sub = new unit__ws__w_socket_subscription_test.MockStreamSubscription();
          let wsub = new src__web_socket__w_socket_subscription.WSocketSubscription(sub, dart.fn(() => {
          }, VoidToNull()));
          let errorHandler = dart.fn(_ => {
          }, dynamicToNull());
          wsub.onError(errorHandler);
          src__frontend__expect.expect(core.identical(sub.onErrorHandler, errorHandler), src__core_matchers.isTrue);
          yield wsub.cancel();
          yield sub.cancel();
        }, core.Null), VoidToFutureOfNull()));
        test.test('onData() should call onData() on the underlying subscription', dart.fn(() => dart.async(function*() {
          let sub = new unit__ws__w_socket_subscription_test.MockStreamSubscription();
          let wsub = new src__web_socket__w_socket_subscription.WSocketSubscription(sub, dart.fn(() => {
          }, VoidToNull()));
          let dataHandler = dart.fn(_ => {
          }, dynamicToNull());
          wsub.onData(dataHandler);
          src__frontend__expect.expect(core.identical(sub.onDataHandler, dataHandler), src__core_matchers.isTrue);
          yield wsub.cancel();
          yield sub.cancel();
        }, core.Null), VoidToFutureOfNull()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  dart.fn(unit__ws__w_socket_subscription_test.main, VoidTovoid$());
  unit__ws__w_socket_subscription_test.MockStreamSubscription$ = dart.generic(T => {
    let StreamSubscriptionOfT = () => (StreamSubscriptionOfT = dart.constFn(async.StreamSubscription$(T)))();
    let TTovoid = () => (TTovoid = dart.constFn(dart.fnTypeFuzzy(dart.void, [T])))();
    class MockStreamSubscription extends src__mock.Mock {
      new() {
        this[onDataHandler] = null;
        this[onDoneHandler] = null;
        this[onErrorHandler] = null;
        super.new();
      }
      get onDataHandler() {
        return this[onDataHandler];
      }
      set onDataHandler(value) {
        this[onDataHandler] = value;
      }
      get onDoneHandler() {
        return this[onDoneHandler];
      }
      set onDoneHandler(value) {
        this[onDoneHandler] = value;
      }
      get onErrorHandler() {
        return this[onErrorHandler];
      }
      set onErrorHandler(value) {
        this[onErrorHandler] = value;
      }
      onData(handleData) {
        this.onDataHandler = handleData;
      }
      onDone(handleDone) {
        this.onDoneHandler = handleDone;
      }
      onError(handleError) {
        this.onErrorHandler = handleError;
      }
      cancel(...args) {
        return async.Future._check(this.noSuchMethod(new dart.InvocationImpl('cancel', args, {isMethod: true})));
      }
      pause(...args) {
        return dart.void._check(this.noSuchMethod(new dart.InvocationImpl('pause', args, {isMethod: true})));
      }
      resume(...args) {
        return dart.void._check(this.noSuchMethod(new dart.InvocationImpl('resume', args, {isMethod: true})));
      }
      asFuture(E) {
        return (...args) => {
          return async.Future$(E)._check(this.noSuchMethod(new dart.InvocationImpl('asFuture', args, {isMethod: true})));
        };
      }
      get isPaused() {
        return core.bool._check(this.noSuchMethod(new dart.InvocationImpl('isPaused', [], {isGetter: true})));
      }
    }
    dart.addTypeTests(MockStreamSubscription);
    const onDataHandler = Symbol("MockStreamSubscription.onDataHandler");
    const onDoneHandler = Symbol("MockStreamSubscription.onDoneHandler");
    const onErrorHandler = Symbol("MockStreamSubscription.onErrorHandler");
    MockStreamSubscription[dart.implements] = () => [StreamSubscriptionOfT()];
    dart.setSignature(MockStreamSubscription, {
      fields: () => ({
        onDataHandler: dart.fieldType(core.Function),
        onDoneHandler: dart.fieldType(core.Function),
        onErrorHandler: dart.fieldType(core.Function)
      }),
      methods: () => ({
        onData: dart.fnType(dart.void, [TTovoid()]),
        onDone: dart.fnType(dart.void, [VoidTovoid()]),
        onError: dart.fnType(dart.void, [core.Function])
      })
    });
    return MockStreamSubscription;
  });
  unit__ws__w_socket_subscription_test.MockStreamSubscription = MockStreamSubscription();
  dart.trackLibraries("test/test__unit__ws__w_socket_subscription_test", {
    "unit/ws/w_socket_subscription_test.dart": unit__ws__w_socket_subscription_test
  }, null);
  // Exports:
  return {
    unit__ws__w_socket_subscription_test: unit__ws__w_socket_subscription_test
  };
});
